<?php
class ControllerModuleMassDiscount extends Controller {

	
	public function index() {   

		$this->load->language('module/mass_discount');
		$this->load->model('mass_discount/mass_discount');
		$this->document->setTitle($this->language->get('heading_title'));
		$this->load->model('setting/setting');
		
		$this->load->model('sale/customer_group');
		$this->data['customer_groups'] = $this->model_sale_customer_group->getCustomerGroups();
		$this->load->model('catalog/category');
				
		$this->data['categories'] = $this->model_catalog_category->getCategories(0);
		
		if (isset($this->request->post['product_category'])) {
			$this->data['product_category'] = $this->request->post['product_category'];
		} elseif (isset($product_info)) {
			$this->data['product_category'] = $this->model_catalog_product->getProductCategories($this->request->get['product_id']);
		} else {
			$this->data['product_category'] = array();
		}		
				
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && ($this->validate())) {
	
		
			$this->session->data['success'] = $this->language->get('text_success');		
			
			$cats = ((isset($this->request->post['product_category']))?implode(",",$this->request->post['product_category']):0);
			
			$data = $this->model_mass_discount_mass_discount->updateDiscount($this->request->post['mass_discount_customer_group'],$this->request->post['mass_discount_rate'], $cats, $this->request->post['mass_discount_start_date'],$this->request->post['mass_discount_expires_date']);
			
			
			
			if( isset( $this->request->post['mode'] ) && $this->request->post['mode'] == 'apply' ) {
				$this->redirect(HTTPS_SERVER . 'index.php?route=module/mass_discount&token=' . $this->session->data['token']);
			}else{
				$this->redirect(HTTPS_SERVER . 'index.php?route=extension/module&token=' . $this->session->data['token']);
			}
			
			
			
			
		}
		
		if( isset( $this->session->data['success'] ) ) {
			$this->data['success'] = $this->session->data['success'];
			unset( $this->session->data['success'] );
		}else{
			$this->data['success'] = '';
		}
		
		$text_strings = array(
				'heading_title',
				'text_enabled',
				'text_disabled',
				'entry_customer_group',
				'entry_status',
				'entry_discount_rate',
				'entry_discount_note',
				'entry_start_date',
				'entry_expires_date',
				'button_apply',
				'button_save',
				'button_cancel',
				'entry_category',
				'text_select_all',
				'text_unselect_all'
		);
				
		foreach ($text_strings as $text) {
			$this->data[$text] = $this->language->get($text);
		}

		
 		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}

  		$this->data['breadcrumbs'] = array();

   		$this->data['breadcrumbs'][] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=common/home&token=' . $this->session->data['token'],
       		'text'      => $this->language->get('text_home'),
      		'separator' => FALSE
   		);

   		$this->data['breadcrumbs'][] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=extension/module&token=' . $this->session->data['token'],
       		'text'      => $this->language->get('text_module'),
      		'separator' => ' :: '
   		);
		
   		$this->data['breadcrumbs'][] = array(
       		'href'      => HTTPS_SERVER . 'index.php?route=module/mass_discount&token=' . $this->session->data['token'],
       		'text'      => $this->language->get('heading_title'),
      		'separator' => ' :: '
   		);
		
		$this->data['action'] = HTTPS_SERVER . 'index.php?route=module/mass_discount&token=' . $this->session->data['token'];
		$this->data['cancel'] = HTTPS_SERVER . 'index.php?route=extension/module&token=' . $this->session->data['token'];



		$config_data = array(
				'mass_discount_customer_group',
				'mass_discount_status',
				'mass_discount_rate',
				'mass_discount_start_date',
				'mass_discount_expires_date'
		);
		
		foreach ($config_data as $conf) {
			if (isset($this->request->post[$conf])) {
				$this->data[$conf] = $this->request->post[$conf];
			} else {
				$this->data[$conf] = $this->config->get($conf);
			}
		}			
		
		$this->template = 'module/mass_discount.tpl';
		$this->children = array(
			'common/header',	
			'common/footer'	
		);
		
		$this->response->setOutput($this->render(TRUE), $this->config->get('config_compression'));
	}
	
	private function validate() {
		if (!$this->user->hasPermission('modify', 'module/mass_discount')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
	

		if (!$this->error) {
			return TRUE;
		} else {
			return FALSE;
		}	
	}
}
?>