<?php
require_once(substr_replace(DIR_SYSTEM, '', -7) . 'vendor/equotix/seo/equotix.php');
class ControllerModuleSEO extends Equotix {
	protected $version = '2.3.2';
	protected $code = 'seo';
	protected $extension = 'SEO Pack';
	protected $extension_id = '68';
	protected $purchase_url = 'seo-pack';
	protected $purchase_id = '3682';
	protected $error = array();
	
	public function index() {   
		$this->language->load('module/seo');

		$this->document->setTitle($this->language->get('heading_title'));
		
		$this->load->model('setting/setting');
				
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('seo', $this->request->post);		
					
			$this->session->data['success'] = $this->language->get('text_success');
		}
				
		$this->data['heading_title'] = $this->language->get('heading_title');
		
		$this->data['tab_general'] = $this->language->get('tab_general');
		$this->data['tab_related'] = $this->language->get('tab_related');
		$this->data['tab_all_seo'] = $this->language->get('tab_all_seo');
		
		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		$this->data['text_delete'] = $this->language->get('text_delete');
		$this->data['text_edit'] = $this->language->get('text_edit');

		$this->data['column_query'] = $this->language->get('column_query');
		$this->data['column_keyword'] = $this->language->get('column_keyword');
		$this->data['column_action'] = $this->language->get('column_action');
		
		$this->data['entry_clear_product'] = $this->language->get('entry_clear_product');
		$this->data['entry_clear_category'] = $this->language->get('entry_clear_category');
		$this->data['entry_clear_manufacturer'] = $this->language->get('entry_clear_manufacturer');
		$this->data['entry_clear_information'] = $this->language->get('entry_clear_information');
		$this->data['entry_clear_related'] = $this->language->get('entry_clear_related');
		$this->data['entry_generate_product'] = $this->language->get('entry_generate_product');
		$this->data['entry_generate_category'] = $this->language->get('entry_generate_category');
		$this->data['entry_generate_manufacturer'] = $this->language->get('entry_generate_manufacturer');
		$this->data['entry_generate_information'] = $this->language->get('entry_generate_information');
		$this->data['entry_generate_related'] = $this->language->get('entry_generate_related');
		$this->data['entry_related_limit'] = $this->language->get('entry_related_limit');
		$this->data['entry_related_random'] = $this->language->get('entry_related_random');

		$this->data['button_clear_product'] = $this->language->get('button_clear_product');
		$this->data['button_clear_category'] = $this->language->get('button_clear_category');
		$this->data['button_clear_manufacturer'] = $this->language->get('button_clear_manufacturer');
		$this->data['button_clear_information'] = $this->language->get('button_clear_information');
		$this->data['button_clear_related'] = $this->language->get('button_clear_related');
		$this->data['button_generate_product'] = $this->language->get('button_generate_product');
		$this->data['button_generate_category'] = $this->language->get('button_generate_category');
		$this->data['button_generate_manufacturer'] = $this->language->get('button_generate_manufacturer');
		$this->data['button_generate_information'] = $this->language->get('button_generate_information');
		$this->data['button_generate_related'] = $this->language->get('button_generate_related');

		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');
		
		if(isset($this->request->post['seo_related_limit'])) {
			$this->data['seo_related_limit'] = $this->request->post['seo_related_limit'];
		} elseif ($this->config->get('seo_related_limit')) {
			$this->data['seo_related_limit'] = $this->config->get('seo_related_limit');
		} else {
			$this->data['seo_related_limit'] = 6;
		}
		
		if(isset($this->request->post['seo_related_random'])) {
			$this->data['seo_related_random'] = $this->request->post['seo_related_random'];
		} elseif ($this->config->get('seo_related_random')) {
			$this->data['seo_related_random'] = $this->config->get('seo_related_random');
		} else {
			$this->data['seo_related_random'] = 1;
		}
		
 		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}
		
		if (isset($this->session->data['success'])) {
			$this->data['success'] = $this->session->data['success'];
			
			unset($this->session->data['success']);
		} else {
			$this->data['success'] = '';
		}

  		$this->data['breadcrumbs'] = array();

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => false
   		);

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_module'),
			'href'      => $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => ' :: '
   		);
		
   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('module/seo', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => ' :: '
   		);
		
		$this->data['token'] = $this->session->data['token'];
		$this->data['action'] = $this->url->link('module/seo', 'token=' . $this->session->data['token'], 'SSL');
		$this->data['cancel'] = $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL');
		$this->data['clear_product'] = $this->url->link('module/seo/clearproduct', 'token=' . $this->session->data['token'], 'SSL');
		$this->data['clear_category'] = $this->url->link('module/seo/clearcategory', 'token=' . $this->session->data['token'], 'SSL');
		$this->data['clear_manufacturer'] = $this->url->link('module/seo/clearmanufacturer', 'token=' . $this->session->data['token'], 'SSL');
		$this->data['clear_information'] = $this->url->link('module/seo/clearinformation', 'token=' . $this->session->data['token'], 'SSL');
		$this->data['clear_related'] = $this->url->link('module/seo/clearrelated', 'token=' . $this->session->data['token'], 'SSL');
		$this->data['generate_product'] = $this->url->link('module/seo/generateproduct', 'token=' . $this->session->data['token'], 'SSL');
		$this->data['generate_category'] = $this->url->link('module/seo/generatecategory', 'token=' . $this->session->data['token'], 'SSL');
		$this->data['generate_manufacturer'] = $this->url->link('module/seo/generatemanufacturer', 'token=' . $this->session->data['token'], 'SSL');
		$this->data['generate_information'] = $this->url->link('module/seo/generateinformation', 'token=' . $this->session->data['token'], 'SSL');

		$this->generateOutput('module/seo.tpl');
	}
	
	public function clearproduct() {
		$this->language->load('module/seo');
		
		if ($this->validate()) {
			$this->db->query("DELETE FROM " . DB_PREFIX . "url_alias WHERE query LIKE 'product_id=%'");
			
			$this->session->data['success'] = $this->language->get('text_success');
			
			$this->index();
		} else {
			$this->index();
		}
	}
	
	public function clearcategory() {
		$this->language->load('module/seo');
		
		if ($this->validate()) {			
			$this->db->query("DELETE FROM " . DB_PREFIX . "url_alias WHERE query LIKE 'category_id=%'");
			
			$this->session->data['success'] = $this->language->get('text_success');
						
			$this->index();
		} else {
			$this->index();
		}
	}
	
	public function clearinformation() {
		$this->language->load('module/seo');
		
		if ($this->validate()) {
			$this->db->query("DELETE FROM " . DB_PREFIX . "url_alias WHERE query LIKE 'information_id=%'");
			
			$this->session->data['success'] = $this->language->get('text_success');
						
			$this->index();
		} else {
			$this->index();
		}
	}
	
	public function clearmanufacturer() {
		$this->language->load('module/seo');
		
		if ($this->validate()) {
			$this->db->query("DELETE FROM " . DB_PREFIX . "url_alias WHERE query LIKE 'manufacturer_id=%'");
			
			$this->session->data['success'] = $this->language->get('text_success');
						
			$this->index();
		} else {
			$this->index();
		}
	}
	
	public function clearrelated() {
		$this->language->load('module/seo');
		
		if ($this->validate()) {
			$this->db->query("DELETE FROM " . DB_PREFIX . "product_related");
			
			$this->session->data['success'] = $this->language->get('text_success');
						
			$this->index();
		} else {
			$this->index();
		}
	}
	
	public function generateproduct() {
		$this->language->load('module/seo');
		
		if ($this->validate()) {
			$this->load->model('catalog/seo');
			
			$query = $this->db->query("SELECT DISTINCT * FROM " . DB_PREFIX . "product p LEFT JOIN " . DB_PREFIX . "product_description pd ON (p.product_id = pd.product_id) WHERE pd.language_id = '" . (int)$this->config->get('config_language_id') . "'");
			
			foreach ($query->rows as $result) {
				$alias = $this->db->query("SELECT query FROM " . DB_PREFIX . "url_alias WHERE query = 'product_id=" . (int)$result['product_id'] . "'");
				
				if (!$alias->num_rows) {
					$keyword = $this->model_catalog_seo->cleanString($result['name']);
					
					$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "url_alias WHERE keyword = '" . $this->db->escape($keyword) . "'");
						
					if ($query->num_rows) {
						$true = true;
						$count = 0;
						
						while ($true) {								
							$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "url_alias WHERE keyword = '" . $this->db->escape($keyword . '-' . $count) . "'");
							
							if ($query->num_rows) {
								$count++;
							} else {
								$true = false;
							}
						}
						
						$this->db->query("INSERT INTO " . DB_PREFIX . "url_alias SET query = 'product_id=" . (int)$result['product_id'] . "', keyword = '" . $this->db->escape($keyword . '-' . $count) . "'");
					} else {
						$this->db->query("INSERT INTO " . DB_PREFIX . "url_alias SET query = 'product_id=" . (int)$result['product_id'] . "', keyword = '" . $this->db->escape($keyword) . "'");
					}
				}
			}
			
			$this->session->data['success'] = $this->language->get('text_success');
						
			$this->index();
		} else {
			$this->index();
		}
	}
	
	public function generatecategory() {
		$this->language->load('module/seo');
		
		if ($this->validate()) {
			$this->load->model('catalog/seo');
			
			$query = $this->db->query("SELECT DISTINCT * FROM " . DB_PREFIX . "category c LEFT JOIN " . DB_PREFIX . "category_description cd ON (c.category_id = cd.category_id) WHERE cd.language_id = '" . (int)$this->config->get('config_language_id') . "'");
			
			foreach ($query->rows as $result) {
				$alias = $this->db->query("SELECT query FROM " . DB_PREFIX . "url_alias WHERE query = 'category_id=" . (int)$result['category_id'] . "'");
				
				if (!$alias->num_rows) {
					$keyword = $this->model_catalog_seo->cleanString($result['name']);
					
					$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "url_alias WHERE keyword = '" . $this->db->escape($keyword) . "'");
						
					if ($query->num_rows) {
						$true = true;
						$count = 0;
						
						while ($true) {								
							$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "url_alias WHERE keyword = '" . $this->db->escape($keyword . '-' . $count) . "'");
							
							if ($query->num_rows) {
								$count++;
							} else {
								$true = false;
							}
						}
						
						$this->db->query("INSERT INTO " . DB_PREFIX . "url_alias SET query = 'category_id=" . (int)$result['category_id'] . "', keyword = '" . $this->db->escape($keyword . '-' . $count) . "'");
					} else {
						$this->db->query("INSERT INTO " . DB_PREFIX . "url_alias SET query = 'category_id=" . (int)$result['category_id'] . "', keyword = '" . $this->db->escape($keyword) . "'");
					}
				}
			}
			
			$this->session->data['success'] = $this->language->get('text_success');
						
			$this->index();
		} else {
			$this->index();
		}
	}
	
	public function generatemanufacturer() {
		$this->language->load('module/seo');
		
		if ($this->validate()) {
			$this->load->model('catalog/seo');
			
			$query = $this->db->query("SELECT manufacturer_id, name FROM " . DB_PREFIX . "manufacturer");
			
			foreach ($query->rows as $result) {
				$alias = $this->db->query("SELECT query FROM " . DB_PREFIX . "url_alias WHERE query = 'manufacturer_id=" . (int)$result['manufacturer_id'] . "'");
				
				if (!$alias->num_rows) {
					$keyword = $this->model_catalog_seo->cleanString($result['name']);
					
					$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "url_alias WHERE keyword = '" . $this->db->escape($keyword) . "'");
						
					if ($query->num_rows) {
						$true = true;
						$count = 0;
						
						while ($true) {								
							$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "url_alias WHERE keyword = '" . $this->db->escape($keyword . '-' . $count) . "'");
							
							if ($query->num_rows) {
								$count++;
							} else {
								$true = false;
							}
						}
						
						$this->db->query("INSERT INTO " . DB_PREFIX . "url_alias SET query = 'manufacturer_id=" . (int)$result['manufacturer_id'] . "', keyword = '" . $this->db->escape($keyword . '-' . $count) . "'");
					} else {
						$this->db->query("INSERT INTO " . DB_PREFIX . "url_alias SET query = 'manufacturer_id=" . (int)$result['manufacturer_id'] . "', keyword = '" . $this->db->escape($keyword) . "'");
					}
				}
			}
			
			$this->session->data['success'] = $this->language->get('text_success');
						
			$this->index();
		} else {
			$this->index();
		}
	}
	
	public function generateinformation() {
		$this->language->load('module/seo');
		
		if ($this->validate()) {
			$this->load->model('catalog/seo');
			
			$query = $this->db->query("SELECT DISTINCT * FROM " . DB_PREFIX . "information i LEFT JOIN " . DB_PREFIX . "information_description id ON i.information_id = id.information_id WHERE id.language_id = '" . (int)$this->config->get('config_language_id') . "'");
			
			foreach ($query->rows as $result) {
				$alias = $this->db->query("SELECT query FROM " . DB_PREFIX . "url_alias WHERE query = 'information_id=" . (int)$result['information_id'] . "'");
				
				if (!$alias->num_rows) {
					$keyword = $this->model_catalog_seo->cleanString($result['title']);
					
					$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "url_alias WHERE keyword = '" . $this->db->escape($keyword) . "'");
						
					if ($query->num_rows) {
						$true = true;
						$count = 0;
						
						while ($true) {								
							$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "url_alias WHERE keyword = '" . $this->db->escape($keyword . '-' . $count) . "'");
							
							if ($query->num_rows) {
								$count++;
							} else {
								$true = false;
							}
						}
						
						$this->db->query("INSERT INTO " . DB_PREFIX . "url_alias SET query = 'information_id=" . (int)$result['information_id'] . "', keyword = '" . $this->db->escape($keyword . '-' . $count) . "'");
					} else {
						$this->db->query("INSERT INTO " . DB_PREFIX . "url_alias SET query = 'information_id=" . (int)$result['information_id'] . "', keyword = '" . $this->db->escape($keyword) . "'");
					}
				}
			}
			
			$this->session->data['success'] = $this->language->get('text_success');
						
			$this->index();
		} else {
			$this->index();
		}
	}
	
	public function generaterelated() {
		$json = array();
		
		$this->language->load('module/seo');
		
		if ($this->validate()) {
			if (isset($this->request->get['page'])) {
				$page = (int)$this->request->get['page'];
			} else {
				$page = 1;
			}
			
			$start = ($page - 1) * 20;
			$limit = 20;
			
			$query = $query = $this->db->query("SELECT COUNT(*) AS total FROM " . DB_PREFIX . "product");
			
			$count = $query->row['total'];
			
			$total_page = ceil($count / $limit);
			
			if ($page < $total_page) {
				$json['next'] = $page + 1;
				
				$json['success'] = sprintf($this->language->get('text_next'), $start, $count);
			} else {
				$json['success'] = $this->language->get('text_success');
			}
			
			$query = $this->db->query("SELECT product_id FROM " . DB_PREFIX . "product LIMIT " . (int)$start . ", " . $limit);
			
			foreach ($query->rows as $result) {				
				$products = $this->db->query("SELECT product_id FROM " . DB_PREFIX . "product_to_category WHERE category_id IN (SELECT DISTINCT category_id FROM " . DB_PREFIX . "product_to_category WHERE product_id = '" . (int)$result['product_id'] . "') AND product_id != '" . (int)$result['product_id'] . "'");
				
				foreach ($products->rows as $product) {
					$query1 = $this->db->query("SELECT * FROM " . DB_PREFIX . "product_related WHERE product_id = '" . (int)$result['product_id'] . "' AND related_id = '" . (int)$product['product_id'] . "'");
					
					if (!$query1->num_rows) {
						$this->db->query("INSERT INTO " . DB_PREFIX . "product_related SET product_id = '" . (int)$result['product_id'] . "', related_id = '" . (int)$product['product_id'] . "'");
						$this->db->query("INSERT INTO " . DB_PREFIX . "product_related SET product_id = '" . (int)$product['product_id'] . "', related_id = '" . (int)$result['product_id'] . "'");
					}
				}
				
			}
		} else {
			$json['error'] = $this->error['warning'];
		}
		
		$this->response->setOutput(json_encode($json));	
	}
	
	public function allseo() {
		$json = array();
		
		if (isset($this->request->get['page'])) {
			$page = (int)$this->request->get['page'];
		} else {
			$page = 1;
		}
		
		$start = ($page - 1) * $this->config->get('config_admin_limit');
		$limit = $this->config->get('config_admin_limit');
		
		$query = $this->db->query("SELECT COUNT(*) as total FROM " . DB_PREFIX . "url_alias");
		
		$pagination = new Pagination();
		$pagination->total = $query->row['total'];
		$pagination->page = $page;
		$pagination->limit = $this->config->get('config_admin_limit');
		$pagination->text = $this->language->get('text_pagination');
		$pagination->url = $this->url->link('module/seo/allseo', 'token=' . $this->session->data['token'] . '&page={page}', 'SSL');

		$json['pagination'] = $pagination->render();
		
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "url_alias LIMIT " . (int)$start . ", " . (int)$limit);
		
		foreach ($query->rows as $result) {
			if (strpos($result['query'], 'product_id=') !== false) {
				$url = 'index.php?route=catalog/product/update&token=' . $this->session->data['token'] . '&' . $result['query'];
			} elseif (strpos($result['query'], 'category_id=') !== false) {
				$url = 'index.php?route=catalog/category/update&token=' . $this->session->data['token'] . '&' . $result['query'];
			} elseif (strpos($result['query'], 'information_id=') !== false) {
				$url = 'index.php?route=catalog/information/update&token=' . $this->session->data['token'] . '&' . $result['query'];
			} elseif (strpos($result['query'], 'manufacturer_id=') !== false) {
				$url = 'index.php?route=catalog/manufacturer/update&token=' . $this->session->data['token'] . '&' . $result['query'];
			} else {
				$url = '';
			}
			
			$json['urls'][] = array(
				'url_alias_id'		=> $result['url_alias_id'],
				'query'				=> $result['query'],
				'keyword'			=> $result['keyword'],
				'url'				=> $url
			);
		}
	
		$this->response->setOutput(json_encode($json));
	}
	
	public function deleteseo() {
		$this->language->load('module/seo');
		
		if ($this->validate()) {
			$id = (int)$this->request->get['url_alias_id'];
			
			$this->db->query("DELETE FROM " . DB_PREFIX . "url_alias WHERE url_alias_id = '" . (int)$id . "'");
			
			$this->session->data['success'] = $this->language->get('text_success');
		}
		
		$this->index();
	}
	
	public function install() {
		$path = substr_replace(DIR_SYSTEM, '', -7);

		if (file_exists($path . 'vqmod/xml/seo_url.xml_') || is_file($path . 'vqmod/xml/seo_url.xml_')) {
			rename($path . 'vqmod/xml/seo_url.xml_', $path . 'vqmod/xml/seo_url.xml');
		}
	}
	
	public function uninstall() {
		$path = substr_replace(DIR_SYSTEM, '', -7);

		if (file_exists($path . 'vqmod/xml/seo_url.xml') || is_file($path . 'vqmod/xml/seo_url.xml')) {
			rename($path . 'vqmod/xml/seo_url.xml', $path . 'vqmod/xml/seo_url.xml_');
		}
	}
	
	protected function validate() {
		if (!$this->user->hasPermission('modify', 'module/seo') || !$this->validated()) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
				
		if (!$this->error) {
			return true;
		} else {
			return false;
		}	
	}
}
?>