<?php
//ADMIN
class ControllerModulesocialdiscounts extends Controller {

    public function index() { 
	 
        $this->load->language('module/socialdiscounts');
        $this->load->model('module/socialdiscounts');
        $this->load->model('setting/store');
        $this->load->model('localisation/language');
        $this->load->model('design/layout');
        $catalogURL = $this->getCatalogURL();
 
        $this->document->addScript($catalogURL . 'admin/view/javascript/ckeditor/ckeditor.js');
        $this->document->addScript($catalogURL . 'admin/view/javascript/socialdiscounts/bootstrap/js/bootstrap.min.js');
		$this->document->addScript($catalogURL . 'admin/view/javascript/socialdiscounts/main.js');
        $this->document->addStyle($catalogURL  . 'admin/view/javascript/socialdiscounts/bootstrap/css/bootstrap.min.css');
        $this->document->addStyle($catalogURL  . 'admin/view/stylesheet/socialdiscounts/font-awesome/css/font-awesome.min.css');
        $this->document->addStyle($catalogURL  . 'admin/view/stylesheet/socialdiscounts/socialdiscounts.css');
        $this->document->addStyle($catalogURL  . 'catalog/view/theme/' . $this->config->get('config_template') . '/stylesheet/socialdiscounts.css');
        $this->document->setTitle($this->language->get('heading_title'));
        if(!isset($this->request->get['store_id'])) {
           $this->request->get['store_id'] = 0; 
        }
	
        $store = $this->getCurrentStore($this->request->get['store_id']);
		
        if (($this->request->server['REQUEST_METHOD'] == 'POST')) { 	
            if (!$this->user->hasPermission('modify', 'module/socialdiscounts')) {
                $this->redirect($this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'));
            }

            if (!empty($_POST['OaXRyb1BhY2sgLSBDb21'])) {
                $this->request->post['socialdiscounts']['LicensedOn'] = $_POST['OaXRyb1BhY2sgLSBDb21'];
            }

            if (!empty($_POST['cHRpbWl6YXRpb24ef4fe'])) {
                $this->request->post['socialdiscounts']['License'] = json_decode(base64_decode($_POST['cHRpbWl6YXRpb24ef4fe']), true);
            }
			if(!isset($this->request->post['socialdiscounts_module'])) {
				$this->request->post['socialdiscounts_module'] = array();
			}
			$this->model_module_socialdiscounts->editSetting('socialdiscounts_module', $this->request->post['socialdiscounts_module'], $this->request->post['store_id']);
            $this->model_module_socialdiscounts->editSetting('socialdiscounts', $this->request->post, $this->request->post['store_id']);
            $this->session->data['success'] = $this->language->get('text_success');
            $this->redirect($this->url->link('module/socialdiscounts', 'store_id='.$this->request->post['store_id'] . '&token=' . $this->session->data['token'], 'SSL'));
        }

        if (isset($this->error['code'])) {
            $this->data['error_code'] = $this->error['code'];
        } else {
            $this->data['error_code'] = '';
        }

        $this->data['breadcrumbs']   = array();
        $this->data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
        );
        $this->data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_module'),
            'href' => $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'),
        );
        $this->data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->url->link('module/socialdiscounts', 'token=' . $this->session->data['token'], 'SSL'),
        );

        $languageVariables = array(
            'entry_code',
            'heading_title',
            'error_input_form',
            'entry_api',
            'entry_secret',
            'entry_preview',
            'entry_design',
            'entry_no_design',
            'entry_wrap_into_widget',
            'entry_yes',
            'entry_no',
            'entry_wrapper_title',
            'entry_custom_css',
            'text_default',
            'share_url',
            'type_of_discount',
            'type_percentage',
            'type_fixed_amount',
            'share_discount',
            'like_discount',
            'tweet_discount',
            'follow_discount',
            'description',
            'text_caption',
            'custom_css',
            'add_your_style_here',
            'facebook_sharing_status',
            'twitter_sharing_status',
            'entry_facebook_button_name',
            'entry_twitter_button_name',
            'entry_consumer_key',
            'consumer_secret',
            'max_count_of_discounts',
            'select_buttons',
            'entry_layout_options',
            'entry_position_options',
            'entry_layout',         
            'entry_position',       
            'entry_status',         
            'entry_sort_order',     
            'entry_layout_options',  
            'entry_position_options',
            'text_content_top', 
            'text_content_bottom',
            'text_column_left', 
            'text_column_right',
            'button_add_module',
            'button_remove',
            'text_enabled',
            'text_disabled',
            'twitter_hash_tag',
            'tweet_message',
            'default_heading_title',
            'custom_design',
            'widget_help',
            'text_background',
            'text_border',
            'text_text',
            'store_front_widget',
            'save_changes',
            'button_cancel',
            'text_settings',
            'text_shares',
            'twitter_profile_name',
            'text_custom',
            'like_page',
            'feed_image',
            'text_action',
            'text_description',
            'text_discount',
            'tooltip_sort_order', 
            'column_sort_order' ,
            'tooltip_description'     
        );
       
        foreach ($languageVariables as $languageVariable) {
            $this->data[$languageVariable] = $this->language->get($languageVariable);
        }
 
        $this->data['stores'] = array_merge(array(0 => array('store_id' => '0', 'name' => $this->config->get('config_name') . ' (' . $this->data['text_default'].')', 'url' => HTTP_SERVER, 'ssl' => HTTPS_SERVER)), $this->model_setting_store->getStores());
        $this->data['error_warning']          = '';  
        $this->data['languages']              = $this->model_localisation_language->getLanguages();
        $this->data['store']                  = $store;
        $this->data['token']                  = $this->session->data['token'];
        $this->data['action']                 = $this->url->link('module/socialdiscounts', 'token=' . $this->session->data['token'], 'SSL');
        $this->data['cancel']                 = $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL');
        $this->data['data']                   = $this->model_module_socialdiscounts->getSetting('socialdiscounts', $store['store_id']);
        $this->data['modules'] 				  = $this->model_module_socialdiscounts->getSetting('socialdiscounts_module', $store['store_id']);
        $this->data['layouts']                = $this->model_design_layout->getLayouts();
        $this->data['catalog_url']                = $catalogURL;
        $this->template = 'module/socialdiscounts.tpl';
        $this->children = array('common/header', 'common/footer');
        $this->response->setOutput($this->render());
    }

    public function shares() {
        $this->load->model('module/socialdiscounts');
        $this->load->language('module/socialdiscounts');
        $this->data['currencyLeft'] = $this->currency->getSymbolLeft($this->config->get('config_currency'));
        $this->data['currencyRight'] = $this->currency->getSymbolRight($this->config->get('config_currency'));
        $this->template = 'module/socialdiscounts/shares.tpl';

        $languageVariables = array(
            'column_name',    
            'column_discount',
            'column_locale',
            'column_gender',
            'column_date',
            'text_settings'
            );
        foreach ($languageVariables as $languageVariable) {
            $this->data[$languageVariable] = $this->language->get($languageVariable);
        }

        if (isset($this->request->get['sort'])) {
            $sort = $this->request->get['sort'];
        } else {
            $sort = 'date_added';
        }

        if (isset($this->request->get['order'])) {
            $order = $this->request->get['order'];
        } else {
            $order = 'DESC';
        }

        if (isset($this->request->get['page'])) {
            $page = $this->request->get['page'];
        } else {
            $page = 1;
        } 

        $url = '';
        if (isset($this->request->get['sort'])) {
            $url .= '&sort=' . $this->request->get['sort'];
        }
        if (isset($this->request->get['order'])) {
            $url .= '&order=' . $this->request->get['order'];
        }
        if (isset($this->request->get['page'])) {
            $url .= '&page=' . $this->request->get['page'];
        }

        $data   = array(
            'sort' => $sort,
            'order' => $order,
            'start' => ($page - 1) * $this->config->get('config_admin_limit'),
            'limit' => $this->config->get('config_admin_limit'),
            'store_id' => $this->request->get['store_id']
        );    

        $shares = $this->model_module_socialdiscounts->getFacebookShares($data);  
        $url = '';
        if ($order == 'ASC') {
            $url .= '&order=DESC';
        } else {
            $url .= '&order=ASC';
        }

        $this->data['facebook_name']       = 'index.php?route=module/socialdiscounts/shares&store_id='.$this->request->get['store_id'].'&token=' . $this->session->data['token'] . '&sort=facebook_name' . $url;
        $this->data['gender'] = 'index.php?route=module/socialdiscounts/shares&store_id='.$this->request->get['store_id'].'&token=' . $this->session->data['token'] . '&sort=gender' . $url;
        $this->data['user_locale']      = 'index.php?route=module/socialdiscounts/shares&store_id='.$this->request->get['store_id'].'&token=' . $this->session->data['token'] . '&sort=user_locale' . $url;
        $this->data['discount_type']      = 'index.php?route=module/socialdiscounts/shares&store_id='.$this->request->get['store_id'].'&token=' . $this->session->data['token'] . '&sort=discount_type' . $url;
        $this->data['discount_value']      = 'index.php?route=module/socialdiscounts/shares&store_id='.$this->request->get['store_id'].'&token=' . $this->session->data['token'] . '&sort=discount_value' . $url;
        $this->data['date_added']      = 'index.php?route=module/socialdiscounts/shares&store_id='.$this->request->get['store_id'].'&token=' . $this->session->data['token'] . '&sort=date_added' . $url;
        
        $this->data['continue'] = $this->url->link('account/account', '', 'SSL');
    
        $url = '';
        if (isset($this->request->get['sort'])) {
            $url .= '&sort=' . $this->request->get['sort'];
        }
        if (isset($this->request->get['order'])) { 
            $url .= '&order=' . $this->request->get['order'];
        } 

        $pagination               = new Pagination();
        $pagination->total        = $this->model_module_socialdiscounts->getTotalShares($this->request->get['store_id']); 
        $pagination->page         = $page;
        $pagination->limit        = $this->config->get('config_admin_limit');
        $pagination->text         = $this->language->get('text_pagination');
        $pagination->url          = 'index.php?route=module/socialdiscounts/shares&store_id='.$this->request->get['store_id'].'&token=' . $this->session->data['token'] . $url . '&page={page}';
        $this->data['pagination'] = $pagination->render();
        $this->data['sort']       = $sort;
        $this->data['order']      = $order;
        $this->data['shares'] = $shares;
        $this->response->setOutput($this->render());
    }
    
    private function getCatalogURL() {
        if (isset($_SERVER['HTTPS']) && (($_SERVER['HTTPS'] == 'on') || ($_SERVER['HTTPS'] == '1'))) {
            $storeURL = HTTPS_CATALOG;
        } else {
            $storeURL = HTTP_CATALOG;
        } 
        return $storeURL;
    }

    private function getServerURL() {
        if (isset($_SERVER['HTTPS']) && (($_SERVER['HTTPS'] == 'on') || ($_SERVER['HTTPS'] == '1'))) {
            $storeURL = HTTPS_SERVER;
        } else {
            $storeURL = HTTP_SERVER;
        } 
        return $storeURL;
    }

    private function getCurrentStore($store_id) {    
        if($store_id && $store_id != 0) {
            $store = $this->model_setting_store->getStore($store_id);
        } else {
            $store['store_id'] = 0;
            $store['name'] = $this->config->get('config_name');
            $store['url'] = $this->getCatalogURL(); 
        }
        return $store;
    }
    
    public function install() {	
	    $this->load->model('module/socialdiscounts');
	    $this->model_module_socialdiscounts->install();
    }
    
    public function uninstall() {
    	$this->load->model('setting/setting');
		
		$this->load->model('setting/store');
		$this->model_setting_setting->deleteSetting('socialdiscounts_module',0);
		$this->model_setting_setting->deleteSetting('socialdiscounts',0);
		$stores=$this->model_setting_store->getStores();
		foreach ($stores as $store) {
			$this->model_setting_setting->deleteSetting('socialdiscounts_module', $store['store_id']);
			$this->model_setting_setting->deleteSetting('socialdiscounts', $store['store_id']);
		}
		
        $this->load->model('module/socialdiscounts');
        $this->model_module_socialdiscounts->uninstall();
    }
}

?>