<?php
/*------------------------------------------------------------------------
# Payment Fee or Discount
# ------------------------------------------------------------------------
# The Krotek
# Copyright (C) 2011-2015 thekrotek.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Website: http://thekrotek.com
# Support: support@thekrotek.com
-------------------------------------------------------------------------*/

class ControllerTotalFeeDiscount extends Controller
{
    private $type = "total";
    private $extension = "fee_discount";
    private $error = array();
    private $options = array(
        'customer_groups' => 'checkbox',
        'tax_class' => 'select',
        'geo_zone' => 'select',
        'status' => 'select',
        'sort_order' => 'input');

    public function index()
    {
        if (version_compare(VERSION, '2.0', '<')) $params = $this->data;
        else $params = array();

        $params['extension'] = $this->extension;
        $params['type'] = $this->type;

        $this->language->load($this->type.'/'.$this->extension);

        $params['heading_title'] = $this->language->get('heading_title');

        $this->document->setTitle($params['heading_title']);

        $this->load->model('setting/setting');

        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
            $this->model_setting_setting->editSetting($this->extension, $this->request->post);
            $this->session->data['success'] = sprintf($this->language->get('message_success'), $params['heading_title']);

            if ($this->request->post['apply']) {
                if (version_compare(VERSION, '2.0', '<')) {
                    $this->redirect($this->url->link($this->type.'/'.$this->extension, 'token='.$this->session->data['token'], 'SSL'));
                } else {
                    $this->response->redirect($this->url->link($this->type.'/'.$this->extension, 'token='.$this->session->data['token'], 'SSL'));
                }
            } else {
                if (version_compare(VERSION, '2.0', '<')) {
                    $this->redirect($this->url->link('extension/'.$this->type, 'token='.$this->session->data['token'], 'SSL'));
                } else {
                    $this->response->redirect($this->url->link('extension/'.$this->type, 'token='.$this->session->data['token'], 'SSL'));
                }
            }
        }

        if (isset($this->session->data['success'])) $params['success'] = $this->session->data['success'];
        else $params['success'] = "";

        $this->session->data['success'] = "";

        /*
        if (ini_get('allow_url_fopen')) {
            if (@simplexml_load_file('http://thekrotek.com/updates.xml')) {
                $xml = simplexml_load_file('http://thekrotek.com/updates.xml');
                $latest = $xml->{$this->extension}->version;
                $current = $this->language->get('heading_version');

                if (version_compare($current, $latest, '=')) {
                    $version = sprintf($this->language->get('heading_latest'), $latest);
                    $class = "latest";
                } elseif (version_compare($current, $latest, '>')) {
                    $version = sprintf($this->language->get('heading_future'), $current);
                    $class = "future";
                } else {
                    $version = sprintf($this->language->get('heading_update'), $latest);
                    $class = "update";
                }
            } else {
                $version = $this->language->get('error_version');
                $class = "error";
            }
        } else { */
            $version = $this->language->get('error_fopen');
            $class = "error";
        // }

        $params['version'] = "<span class='version ".$class."'>".$version."</span>";

        if (version_compare(VERSION, '2.0', '>=')) $params['text_edit'] = sprintf($this->language->get('text_edit_title'), $this->language->get('heading_title'));

        $params['text_yes'] = $this->language->get('text_yes');
        $params['text_no'] = $this->language->get('text_no');
        $params['text_enabled'] = $this->language->get('text_enabled');
        $params['text_disabled'] = $this->language->get('text_disabled');
        $params['text_select_all'] = $this->language->get('text_select_all');
        $params['text_unselect_all'] = $this->language->get('text_unselect_all');

        $params['button_save'] = $this->language->get('button_save');
        $params['button_apply'] = $this->language->get('button_apply');
        $params['button_cancel'] = $this->language->get('button_cancel');

        $params['breadcrumbs'] = array();

        $params['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/'.(version_compare(VERSION, '2.0', '<') ? 'home' : 'dashboard'), 'token='.$this->session->data['token'], 'SSL'),
            'separator' => false
        );

        $params['breadcrumbs'][] = array(
            'text' => $this->language->get('text_'.$this->type),
            'href' => $this->url->link('extension/'.$this->type, 'token='.$this->session->data['token'], 'SSL'),
            'separator' => ' :: '
        );

        $params['breadcrumbs'][] = array(
            'text' => $params['heading_title'],
            'href' => $this->url->link($this->type.'/'.$this->extension, 'token='.$this->session->data['token'], 'SSL'),
            'separator' => ' :: '
        );

        $params['action'] = $this->url->link($this->type.'/'.$this->extension, 'token='.$this->session->data['token'], 'SSL');
        $params['cancel'] = $this->url->link('extension/'.$this->type, 'token='.$this->session->data['token'], 'SSL');

        if (version_compare(VERSION, '2.1', '<')) {
            $this->load->model('sale/customer_group');
            $groupmodel = 'model_sale_customer_group';
        } else {
            $this->load->model('customer/customer_group');
            $groupmodel = 'model_customer_customer_group';
        }

        $customer_groups = $this->{$groupmodel}->getCustomerGroups();

        foreach ($customer_groups as $customer_group) {
            $params['customer_groups'][] = array($customer_group['customer_group_id'], $customer_group['name']);
        }

        $this->load->model('localisation/tax_class');
        $taxes = $this->model_localisation_tax_class->getTaxClasses();

        $params['tax_class'][] = array(0, $this->language->get('text_none'));

        foreach ($taxes as $tax) {
            $params['tax_class'][] = array($tax['tax_class_id'], $tax['title']);
        }

        $this->load->model('localisation/geo_zone');
        $geo_zones = $this->model_localisation_geo_zone->getGeoZones();

        $params['geo_zone'][] = array(0, $this->language->get('text_all_zones'));

        foreach ($geo_zones as $geo_zone) {
            $params['geo_zone'][] = array($geo_zone['geo_zone_id'], $geo_zone['name']);
        }

        $this->load->model('localisation/order_status');
        $statuses = $this->model_localisation_order_status->getOrderStatuses();

        $params['order_status'] = array();

        foreach ($statuses as $status) {
            $params['order_status'][] = array($status['order_status_id'], $status['name']);
        }

        $params['status'] = array(
            array('0', $params['text_disabled']),
            array('1', $params['text_enabled']));

        $this->load->model('localisation/language');
        $params['languages'] = $this->model_localisation_language->getLanguages();

        $this->load->model('localisation/stock_status');
        $statuses = $this->model_localisation_stock_status->getStockStatuses();

        foreach ($statuses as $status) {
            $params['stock_status'][] = array($status['stock_status_id'], $status['name']);
        }

        $params['stylesheet'] = $this->extension;

        /* Extension specific code */

        $params['options'] = array_merge(array(
            'general_settings' => 'title',
            'fee_min' => 'input',
            'discount_min' => 'input',
            'round' => 'input',
            'add_name' => 'radio',
            'add_value' => 'radio',
            'hide_total' => 'radio',
            'add_to' => 'select',
            'add_info' => 'radio',
            'totals_fee' => 'checkbox',
            'totals_discount' => 'checkbox'), $this->options);

        unset($params['options']['geo_zone']);

        $params[$this->extension.'_general_settings'] = $this->language->get('general_settings');

        $params['entry_payments'] = $this->language->get('entry_payments');
        $params['help_payments'] = $this->language->get('help_payments');

        if (version_compare(VERSION, '2.0', '<')) {
            $this->load->model('setting/extension');
            $payments = $this->model_setting_extension->getInstalled('payment');
        } else {
            $this->load->model('extension/extension');
            $payments = $this->model_extension_extension->getInstalled('payment');
        }

        if ($payments) {
            $params['payments'] = array();

            $items = $this->config->get($this->extension.'_payments');

            foreach ($payments as $payment) {
                $this->language->load('payment/'.$payment);

                $params['payments'][$payment] = array();
                $params['payments'][$payment]['title'] = $this->language->get('heading_title');

                if (isset($this->request->post[$this->extension.'_payments'][$payment])) {
                    $params['payments'][$payment]['value'] = $this->request->post[$this->extension.'_payments'][$payment];
                } elseif (isset($items[$payment])) {
                    $params['payments'][$payment]['value'] = $items[$payment];
                } else {
                    $params['payments'][$payment]['value'] = "";
                }
            }
        }

        if (version_compare(VERSION, '2.0', '<')) {
            $this->load->model('setting/extension');
            $totals = $this->model_setting_extension->getInstalled('total');
        } else {
            $this->load->model('extension/extension');
            $totals = $this->model_extension_extension->getInstalled('total');
        }

        $params['totals'] = array();

        $exclude = array('sub_total', $this->extension);

        foreach ($totals as $total) {
            if (!in_array($total, $exclude)) {
                $this->language->load('total/'.$total);
                $params['totals'][] = array($total, $this->language->get('heading_title'));
            }
        }

        $this->language->load($this->type.'/'.$this->extension);

        $params['totals_fee'] = $params['totals'];
        $params['totals_discount'] = $params['totals'];
        $params['add_to'] = $params['totals'];

        /* Generic code */

        foreach ($params['options'] as $key => $type) {
            $params['entry_'.$key] = $this->language->get('entry_'.$key);
            $params['help_'.$key] = $this->language->get('help_'.$key);

            $from_post = (isset($this->request->post[$this->extension.'_'.$key]) ? $this->request->post[$this->extension.'_'.$key] : "");
            $from_config = $this->config->get($this->extension.'_'.$key);
            $default = ($type == 'checkbox' ? array() : "");

            if (!isset($params[$this->extension.'_'.$key])) {
                if (!empty($from_post)) $params[$this->extension.'_'.$key] = $from_post;
                elseif (isset($from_config)) $params[$this->extension.'_'.$key] = $from_config;
                else $params[$this->extension.'_'.$key] = $default;
            }
        }

        if (isset($this->session->data['errors'])) {
            foreach ($this->session->data['errors'] as $key => $text) {
                $this->error[$key] = $text;
            }

            unset($this->session->data['errors']);
        }

        if (!empty($this->error)) {
            $params['errors'] = $this->error;
        } else {
            $params['errors'] = "";
        }

        if (version_compare(VERSION, '2.0', '<')) {
            $this->data = $params;
            $this->template = $this->type.'/'.$this->extension.'.tpl';
            $this->children = array('common/header', 'common/footer');
            $this->response->setoutput($this->render(true));
        } else {
            $data = $params;
            $data['header'] = $this->load->controller('common/header');
            $data['column_left'] = $this->load->controller('common/column_left');
            $data['footer'] = $this->load->controller('common/footer');
            $this->response->setOutput($this->load->view($this->type.'/'.$this->extension.'.tpl', $data));
        }
    }

    private function validate()
    {
        if (!$this->user->hasPermission('modify', $this->type.'/'.$this->extension)) {
            $this->error['warning'] = sprintf($this->language->get('error_permission'), $this->language->get('heading_title'));
        }

        /* Extension specific code */

        foreach ($this->request->post[$this->extension.'_payments'] as $key => $payment) {
            if (strpos($payment, "%")) $payment = str_replace("%", "", $payment);

            if (!empty($payment) && !is_numeric($payment)) {
                $this->language->load('payment/'.$key);
                $this->error[] = sprintf($this->language->get('error_bad_value'), $this->language->get('heading_title'));
            }
        }

        $this->language->load($this->type.'/'.$this->extension);

        /* Generic code */

        $numerics = array('fee_min', 'discount_min', 'round', 'sort_order');
        $percent = array();
        $nonempty = array('customer_groups');

        $fields = array_unique(array_merge($numerics, array_merge($percent, $nonempty)));
        $post = $this->request->post;

        if ($fields) {
            foreach ($fields as $field) {
                if (isset($post[$this->extension.'_'.$field])) {
                    $value = $post[$this->extension.'_'.$field];

                    if (in_array($field, $nonempty) && !$value) {
                        $this->error[] = sprintf($this->language->get('error_empty'), $this->language->get('entry_'.$field));
                    } elseif (!is_array($value)) {
                        $value = trim($value, "%");

                        if (!empty($value) && !is_numeric($value)) {
                            if (in_array($field, $numerics)) {
                                $this->error[] = sprintf($this->language->get('error_numerical'), $this->language->get('entry_'.$field));
                            } elseif (in_array($field, $percent)) {
                                $this->error[] = sprintf($this->language->get('error_percent'), $this->language->get('entry_'.$field));
                            }
                        } elseif ($value < 0) {
                            $this->error[] = sprintf($this->language->get('error_positive'), $this->language->get('entry_'.$field));
                        }
                    }
                } elseif (in_array($field, $nonempty)) {
                    $this->error[] = sprintf($this->language->get('error_empty'), $this->language->get('entry_'.$field));
                }
            }
        }

        if (!$this->error) return true;
        else return false;
    }
}

?>