$(document).ready(function() {
	navOptions();
	widgetTabOptions();
	facebookTabOptions();
	twitterTabOptions();
	loadFacebookShares();
	discountTabOptions();
	tofbkeCSScheckbox();
	createBinds();
	handleInputErrors();
	checkForLikeUrl();
	checkForShareUrl();
	checkForLikeUrlAndShareUrl();
});

function checkForLikeUrlAndShareUrl() {
	if ($("#likeUrlCurrent").attr("checked")) {
		$('.likeUrlField').addClass('hidden');
	} else {
		$('.hidden.likeUrlField').removeClass('hidden');
	} 
	if ($("#shareUrlCurrent").attr("checked")) {
		$('.shareUrlField').addClass('hidden');
	} else {
		$('.hidden.shareUrlField').removeClass('hidden');
	}
}
function checkForLikeUrl() {
	$('input[name="socialdiscounts[facebooklikeUrlCheck]"]').on('change', function(e){
		if ($("#likeUrlCurrent").attr("checked")) {
			$('.likeUrlField').addClass('hidden');
		} else {
			$('.hidden.likeUrlField').removeClass('hidden');
		}            
    });	
}
function checkForShareUrl() {
	$('input[name="socialdiscounts[facebookshareUrlCheck]"]').on('change', function(e){
		if ($("#shareUrlCurrent").attr("checked")) {
			$('.shareUrlField').addClass('hidden');
		} else {
			$('.hidden.shareUrlField').removeClass('hidden');
		}            
    });	
}
function handleInputErrors() {
    var createAllErrors = function() {
        var form = $( this ),
            errorList = $( "#formError");
	
        var showAllErrorMessages = function() {
            errorList.empty();

            // Find all invalid fields within the form.
            html = '';
            if(form.find( ":invalid" ).length > 0){
	             html += '<h5>' + error_input_form + '</h5>' ;
	             html += '<ul class="errorInfo">';
            } 
            var invalidFields = form.find( ":invalid" ).each( function( index, node ) {
                html += '<li><a class="errorTabLink" data-link="#' + $(this).parents('.tab-pane.main').attr('id') + '"><i class="' + $('[href=#' + $(this).parents('.tab-pane.main').attr('id') + ']').children('i').attr('class') + '"></i>' + $('[href=#' + $(this).parents('.tab-pane.main').attr('id') + ']').text() + '</a></li>';
             	$(this).parent().addClass('has-error'); 	
            });
            html += '</ul>';
            if(form.find( ":invalid" ).length > 0) {
            	errorList.show().append(html);
            }
            $('.errorTabLink').live('click', function(e){
				e.preventDefault();
				$('[href=' + $(this).attr('data-link') + ']' ).trigger('click');
			});
        };

        // Support Safari
        form.on( "submit", function( event ) {
            if ( this.checkValidity && !this.checkValidity() ) {
                $( this ).find( ":invalid" ).first().focus();
                event.preventDefault();
            }
        });

        $( "button[type='submit']", form ).on( "click", function() {
        	$('.has-error').removeClass('has-error');
        	showAllErrorMessages();
        });

        $( "input", form ).on( "keypress", function( event ) {
            var type = $( this ).attr( "type" );
            if ( /date|email|month|number|search|tel|text|time|url|week/.test ( type )
              && event.keyCode == 13 ) {
                showAllErrorMessages();
            }
        });
    };
    $( "form" ).each( createAllErrors );
}

function navOptions() {
		if (window.localStorage && window.localStorage['currentTab']) {
	    $('.mainMenuTabs a[href='+window.localStorage['currentTab']+']').trigger('click');  
	}
	if (window.localStorage && window.localStorage['currentSubTab']) {
	    $('a[href='+window.localStorage['currentSubTab']+']').trigger('click');  
	}
	$('.fadeInOnLoad').css('visibility','visible');
	$('.mainMenuTabs a[data-toggle="tab"]').click(function() {
	    if (window.localStorage) {
	        window.localStorage['currentTab'] = $(this).attr('href');
	    }
	});
	
	$('a[data-toggle="tab"]:not(.mainMenuTabs a[data-toggle="tab"])').click(function() {
	    if (window.localStorage) {
	        window.localStorage['currentSubTab'] = $(this).attr('href');
	    }
	});
	
	$('select[name="selectStore"]').on('change', function(e) {
	$('.btn.btn-primary.save-changes').trigger('click');
	    window.location="index.php?route=module/socialdiscounts&store_id=" + $('select[name="selectStore"]').val() + "&token=" + token;
	})
}

function loadFacebookShares(){ 	
	$.ajax({
        url:'index.php?route=module/socialdiscounts/shares&token=' + token + '&store_id=' + store_id,
        success: function(data) {
            $('#shares_sub_tab').html(data);
            $('a[href="#facebook_sub_tab"]').trigger('click');
        }
    })
}

function facebookTabOptions(){
	 if($('select[name="socialdiscounts[facebookEnabled]"]').val() == 'yes') {
        $('.hidden.facebookOptions').removeClass('hidden');
        $('input[name="socialdiscounts[facebookAPIKey]"]').attr('required', 'required');
        $('input[name="socialdiscounts[facebookAPISecret]"]').attr('required', 'required');  
        if($('input[name="socialdiscounts[facebookShare]"]').prop('checked') && $('select[name="socialdiscounts[facebookEnabled]"]').val() == 'yes') {
            $('.hidden.shareButtonOptions').removeClass('hidden');
        }
    }
    
    $('select[name="socialdiscounts[facebookEnabled]"]').on('change', function(e){
        if($('select[name="socialdiscounts[facebookEnabled]"]').val() == 'yes') {
            $('.hidden.facebookOptions').removeClass('hidden');
            $('input[name="socialdiscounts[facebookAPIKey]"]').attr('required', 'required');
            $('input[name="socialdiscounts[facebookAPISecret]"]').attr('required', 'required');
            if($('input[name="socialdiscounts[facebookShare]"]').prop('checked') && $('select[name="socialdiscounts[facebookEnabled]"]').val() == 'yes') {
                $('.hidden.shareButtonOptions').removeClass('hidden');
                $('input[name="socialdiscounts[facebookShareUrl]"]').attr('required', 'required');
                $('input[name^="socialdiscounts\[facebookButtonName_"]').attr('required', 'required');
            }
        } else {
            $('.facebookOptions').addClass('hidden');
            $('.shareButtonOptions').addClass('hidden');
            $('input[name="socialdiscounts[facebookAPIKey]"]').removeAttr('required');
            $('input[name="socialdiscounts[facebookAPISecret]"]').removeAttr('required');
            $('input[name="socialdiscounts[facebookShareUrl]"]').removeAttr('required');
            $('input[name^="socialdiscounts\[facebookButtonName_"]').removeAttr('required');
        }
    });
    
    $('.facebookButtonPreview').append('<div class="' + $('select[name="socialdiscounts[facebookButtonDesign]"]').val() + '"><a class="' + $('select[name="socialdiscounts[facebookButtonDesign]"]').val() + '"><span></span></a></div>'); 
    
    $('select[name="socialdiscounts[facebookButtonDesign]"]').on('change', function(e) { 
        $('.facebookButtonPreview div').remove();
        $('.facebookButtonPreview').append('<div class="' + $(this).val() + '"><a class="' + $(this).val() + '"><span></span>Button peview</a></div>');

        $.each($('input[name^="socialdiscounts\[facebookButtonName_"]'), function(index){ 
            $(this).parent().parent().next().children().children('a').html('<span></span>' + $(this).val());   
        });      
    });

    $.each($('input[name^="socialdiscounts\[facebookButtonName_"]'), function(index){
        $(this).parent().parent().next().children().children('a').html('<span></span>' + $(this).val());   
    });

    $('input[name^="socialdiscounts\[facebookButtonName_"]').keyup(function() {    
        $(this).parent().parent().next().children().children('a').html('<span></span>' + $(this).val());    
    });
    
    if($('input[name="socialdiscounts[facebookShare]"]').prop('checked') && $('select[name="socialdiscounts[facebookEnabled]"]').val() == 'yes') {
        $('.hidden.shareButtonOptions').removeClass('hidden');
    }

    $('input[name="socialdiscounts[facebookShare]"]').on('change', function(e) {
            if($('.hidden.shareButtonOptions').length){
                $('.hidden.shareButtonOptions').removeClass('hidden');
            } else {
                $('.shareButtonOptions').addClass('hidden');
                $('input[name="socialdiscounts[facebookShareUrl]"]').removeAttr('required');
                $('input[name^="socialdiscounts\[facebookButtonName_"]').removeAttr('required');
            }
    });
    
}

function twitterTabOptions() {
	if($('select[name="socialdiscounts[twitterEnabled]"]').val() == 'yes') {
        $('.hidden.twitterOptions').removeClass('hidden');
        if($('input[name="socialdiscounts[twitterTweet]"]').prop('checked')) {
            $('input[name="socialdiscounts[twitterHashTag]"]').attr('required', 'required');
        }
    }

    $('select[name="socialdiscounts[twitterEnabled]"]').on('change', function(e){
        if($('select[name="socialdiscounts[twitterEnabled]"]').val() == 'yes') {
            $('.hidden.twitterOptions').removeClass('hidden');
            $('input[name="socialdiscounts[twitterConsumerKey]"]').attr('required', 'required');
            $('input[name="socialdiscounts[twitterConsumerSecret]"]').attr('required', 'required');
            $('input[name="socialdiscounts[twitterShareUrl]"]').attr('required', 'required');

        } else {
            $('.twitterOptions').addClass('hidden');
            $('input[name="socialdiscounts[twitterConsumerKey]"]').removeAttr('required');
            $('input[name="socialdiscounts[twitterConsumerSecret]"]').removeAttr('required');
            $('input[name="socialdiscounts[twitterShareUrl]"]').removeAttr('required');
        }
    });
    
    $('.twitterButtonPreview a').addClass($('select[name="socialdiscounts[ButtonDesign]"]').val());
    
    $('select[name="socialdiscounts[ButtonDesign]"]').on('change', function(e) {
        $('.twitterButtonPreview a').removeClass();
        $('.twitterButtonPreview a').attr("style",'');
        $('.twitterButtonPreview a').addClass($('select[name="socialdiscounts[ButtonDesign]"]').val());
        $.each($('input[name^="socialdiscounts\[twitterButtonName_"]'), function(index){
            $(this).parent().parent().next().children('a').html($(this).val());   
        });      
    })

    $.each($('input[name^="socialdiscounts\[twitterButtonName_"]'), function(index){
        $(this).parent().parent().next().children('a').html($(this).val());   
    });

    $('input[name^="socialdiscounts\[twitterButtonName_"]').keyup(function() {    
        $(this).parent().parent().next().children('a').html($(this).val());    
    });

}

function widgetTabOptions(){ 

	if ($('select[name="socialdiscounts[customDesign]"]').val() == 'default') {
		$('.customCssForm').addClass('hidden');
	} else {
		$('.hiddeable').removeClass('hidden');	
	}
	
	$('select[name="socialdiscounts[customDesign]"]').live('change', function(){
		if ($('select[name="socialdiscounts[customDesign]"]').val() == 'default') {
			$('.customCssForm').addClass('hidden');
		} else {
			$('.customCssForm').removeClass('hidden');	;	
		}
	});
}

function discountTabOptions() {
	discountTypes = $('select[name^="socialdiscounts[buttons]"][name$="[type]"]');
    for(var  k = 0; k < discountTypes.length; k++) {
   		if($(discountTypes[k]).val() == 'P') {
	   		$(discountTypes[k]).parents('tr').find('input[name^="socialdiscounts[buttons]"][name$="[value]"]').after('<span id="percentageAddon" class="input-group-addon">%</span>');
		  	$(discountTypes[k]).parents('tr').find('input[name^="socialdiscounts[buttons]"][name$="[value]"]').attr('max',"100");
		
		} else {
		  	$(discountTypes[k]).parents('tr').find('input[name^="socialdiscounts[buttons]"][name$="[value]"]').after('<span id="currencyAddon" class="input-group-addon">' + config_currency  + '</span>')
		  	$(discountTypes[k]).parents('tr').find('input[name^="socialdiscounts[buttons]"][name$="[value]"]').attr('max');
		}
	}
	$('select[name^="socialdiscounts[buttons]"][name$="[type]"]').on('change', function(e){ 
	  	if($(this).val() == 'P') {
		    $(this).parents('tr').find('#currencyAddon').remove();
		    $(this).parents('tr').find('input[name^="socialdiscounts[buttons]"][name$="[value]"]').after('<span id="percentageAddon" class="input-group-addon">%</span>');
		    $(this).parents('tr').find('input[name^="socialdiscounts[buttons]"][name$="[value]"]').attr('max',"100");
	  	} else {
		    $(this).parents('tr').find('#percentageAddon').remove();
		    $(this).parents('tr').find('input[name^="socialdiscounts[buttons]"][name$="[value]"]').after('<span id="currencyAddon" class="input-group-addon">' + config_currency + '</span>')
		    $(this).parents('tr').find('input[name^="socialdiscounts[buttons]"][name$="[value]"]').attr('max',"100"); 
	  } 
	});	
	
	if($('#selectbasic2').val() == 'P') {
   		$('input[name^="socialdiscounts[basic]"][name$="[value]"]').after('<span id="percentageAddon" class="input-group-addon">%</span>');
	  	$('input[name^="socialdiscounts[basic]"][name$="[value]"]').attr('max',"100");
	} else {
		$('input[name^="socialdiscounts[basic]"][name$="[value]"]').after('<span id="currencyAddon" class="input-group-addon">' + config_currency  + '</span>')
		$('input[name^="socialdiscounts[basic]"][name$="[value]"]').attr('max');
	}
	
	$('select[name^="socialdiscounts[basic]"][name$="[type]"]').on('change', function(e){ 
	  	if($(this).val() == 'P') {
		    $(this).parents('tr').find('#currencyAddon').remove();
		    $(this).parents('tr').find('input[name^="socialdiscounts[basic]"][name$="[value]"]').after('<span id="percentageAddon" class="input-group-addon">%</span>');
		    $(this).parents('tr').find('input[name^="socialdiscounts[basic]"][name$="[value]"]').attr('max',"100");
	  	} else {
		    $(this).parents('tr').find('#percentageAddon').remove();
		    $(this).parents('tr').find('input[name^="socialdiscounts[basic]"][name$="[value]"]').after('<span id="currencyAddon" class="input-group-addon">' + config_currency + '</span>')
		    $(this).parents('tr').find('input[name^="socialdiscounts[basic]"][name$="[value]"]').attr('max',"100"); 
	  } 
	});
}
var tofbkeCSScheckbox = function() {
  $('input[type=checkbox][id^=buttonPosCheckbox]').each(function(index, element) {
    if ($(this).is(':checked')) {
      $($(this).attr('data-textinput')).removeAttr('disabled');
    } else {
      $($(this).attr('data-textinput')).attr('disabled','disabled');
    }
  });
}

var createBinds = function() {
  $('input[type=checkbox][id^=buttonPosCheckbox]').unbind('change').bind('change', function() {
    tofbkeCSScheckbox();
  });
  
  $('.widgetPositionOptionBox').unbind('change').bind('çhange', function() {
    $($(this).attr('data-checkbox')).removeAttr('checked');
    tofbkeCSScheckbox();
  });
};

function addModule() {
  	html  = '<tbody style="display:none;" id="module-row' + module_row + '">';
  	html += '  <tr>';
  	html += '    <td class="left col-xs-3">';
  	html += '<div class="form-group modulePositioning">';
  	html += ' <label>' + entry_status + '</label>';
  	html += '    <select name="socialdiscounts_module[' + module_row + '][status]" class="form-control">';
	html += '      <option value="1" selected="selected">' + text_enabled + '</option>';
	html += '      <option value="0">' + text_disabled + '</option>';
	html += '    </select></div> ';
	
	html += '<div class="form-group modulePositioning">';
	html += '	<label>' + entry_layout  + '</label>'
  	html += '  <select name="socialdiscounts_module[' + module_row + '][layout_id]" class="form-control">';
  	for (var i in layouts) {
  		html += '      <option value="' + layouts[i]["layout_id"] + '">' + layouts[i]["name"] + '</option>';
   	} 
	html += '    </select></div>';
	
  	html += '<div class="form-group modulePositioning"><label>' + entry_sort_order + '</label><input class="form-control" type="number" name="socialdiscounts_module['+ module_row + '][sort_order]" value="0" /></div>';
  	html += '    </td>';
  	html += '    <td class="left">';
 	html += '<div class="widgetPositionOpenCart"><div class="radio"><label for="buttonPos' + module_row + '_1"><input checked="checked" type="radio" style="width:auto" name="socialdiscounts_module[' + module_row + '][position]" id="buttonPos' + module_row + '_1" class="widgetPositionOptionBox" data-checkbox="#buttonPosCheckbox_' + module_row + '" value="content_top" />' + text_content_top  + '</label></div><div class="positionSampleBox"><label for="buttonPos' + module_row + '_1"><img class="img-thumbnail" src="view/image/socialdiscounts/content_top.png" title="' + text_content_top  + '" border="0" /></label></div></div>';
  	html += '<div class="widgetPositionOpenCart"><div class="radio"><label for="buttonPos' + module_row + '_2"><input type="radio" style="width:auto" name="socialdiscounts_module[' + module_row + '][position]" id="buttonPos' + module_row + '_2" class="widgetPositionOptionBox" data-checkbox="#buttonPosCheckbox_' + module_row + '" value="content_bottom" />' + text_content_bottom  + '</label></div><div class="positionSampleBox"><label for="buttonPos' + module_row + '_2"><img  class="img-thumbnail" src="view/image/socialdiscounts/content_bottom.png" title="' + text_content_bottom  + '" border="0" /></label></div></div>';
  	html += '<div class="widgetPositionOpenCart"><div class="radio"><label for="buttonPos' + module_row + '_3"><input type="radio" style="width:auto" name="socialdiscounts_module[' + module_row + '][position]" id="buttonPos' + module_row + '_3" class="widgetPositionOptionBox" data-checkbox="#buttonPosCheckbox_' + module_row + '" value="column_left" />' + text_column_left  + '</label></div><div class="positionSampleBox"><label for="buttonPos' + module_row + '_3"><img  class="img-thumbnail" src="view/image/socialdiscounts/column_left.png" title="' + text_column_left  + '" border="0" /></label></div></div>';
  	html += '<div class="widgetPositionOpenCart last"><div class="radio"><label for="buttonPos' + module_row + '_4"><input type="radio" style="width:auto" name="socialdiscounts_module[' + module_row + '][position]" id="buttonPos' + module_row + '_4" class="widgetPositionOptionBox" data-checkbox="#buttonPosCheckbox_' + module_row + '" value="column_right" />' + text_column_right  + '</label></div><div class="positionSampleBox"><label for="buttonPos' + module_row + '_4"><img  class="img-thumbnail" src="view/image/socialdiscounts/column_right.png" title="' + text_column_right  + '" border="0" /></label></div></div>';
  	html += '    </td>';
  	html += '    <td class="left" style="vertical-align:bottom;"><a onclick="$(\'#module-row' + module_row + '\').remove();" class="btn btn-danger"><i class="fa fa-times"></i>&nbsp;' + button_remove + '</a></td>';
  	html += '  </tr>';
 	html += '</tbody>';
  
	$('#module tfoot').before(html);
	$('#module-row' + module_row).fadeIn();
	createBinds();
	module_row++;
}