<?php
    if (version_compare(VERSION, '2', '>=')) {
        echo $header;
        echo $column_left;
    } else { ?>
        <!DOCTYPE html>
        <html dir="ltr" lang="en">
        <head>
            <meta charset="UTF-8" />
            <title>Export / Import Pro</title>
            <?php foreach ($styles as $style) { ?>
                <link type="text/css" href="<?php echo $style['href']; ?>" rel="<?php echo $style['rel']; ?>" media="<?php echo $style['media']; ?>" />
            <?php } ?>
            <?php foreach ($scripts as $script) { ?>
                <script type="text/javascript" src="<?php echo $script; ?>"></script>
            <?php } ?>
        </head>
        <body>

    <?php } ?>
<div id="content">
    <div class="page-header">
        <div class="container-fluid">
            <div class="pull-right">
                <?php if (!empty($button_apply_allowed)){ ?>
                  <button onclick="ajax_loading_open();$('input[name=no_exit]').val(1);save_configuration_ajax($('form#<?= $extension_name; ?>'));" type="submit" form="form-account" data-toggle="tooltip" title="<?php echo $apply_changes; ?>" class="btn btn-primary"><i class="fa fa-check"></i></button>
                <?php } ?>

                <?php if (!empty($button_save_allowed)){ ?>
                  <button onclick="ajax_loading_open();$('input[name=no_exit]').val(0);$('form#<?php echo $form_view['id']; ?>').submit()" type="submit" form="form-account" data-toggle="tooltip" title="<?php echo $button_save; ?>" class="btn btn-primary"><i class="fa fa-save"></i></button>
                <?php } ?>

                <a href="<?php echo $cancel; ?>" data-toggle="tooltip" title="<?php echo $button_cancel; ?>" class="btn btn-default"><i class="fa fa-reply"></i></a></div>
                <h1><?php echo $heading_title; ?></h1>
                <ul class="breadcrumb">
                    <?php foreach ($breadcrumbs as $breadcrumb) { ?>
                        <li><a href="<?php echo $breadcrumb['href']; ?>"><?php echo $breadcrumb['text']; ?></a></li>
                    <?php } ?>
                </ul>
            </div>
        </div>
        <div class="container-fluid">
            <?php
            $session_msg_types = array('error', 'error_expired', 'new_version', 'info' ,'success');

            foreach ($session_msg_types as $key => $msn_type)
            {
               foreach ($_SESSION as $session_key => $value)
               {
                    if($msn_type == $session_key && !is_array($value))
                    {
                        ${'session_message_'.$msn_type} = $value;
                        unset($_SESSION[$session_key]);
                        break;
                    }
                    elseif(is_array($value))
                    {
                        foreach ($value as $session_key_2 => $value_2)
                        {
                            if($msn_type == $session_key_2 && !is_array($value_2))
                            {
                                ${'session_message_'.$msn_type} = $value_2;
                                unset($_SESSION[$session_key][$session_key_2]);
                                break;
                            }
                        }
                    }
               }
            }
            ?>

            <?php if (!empty($session_message_new_version)) { ?>
                <div class="alert alert-info"><i class="fa fa-exclamation-circle"></i> <?php echo $session_message_new_version; ?>
                    <button type="button" class="close" data-dismiss="alert">&times;</button>
                </div>
            <?php } ?>
            <?php if (!empty($session_message_error_expired)) { ?>
                <div class="alert alert-info"><i class="fa fa-exclamation-circle"></i> <?php echo $session_message_error_expired; ?>
                    <button type="button" class="close" data-dismiss="alert">&times;</button>
                </div>
            <?php } ?>
            <?php if (!empty($session_message_error)) { ?>
                <div class="alert alert-danger"><i class="fa fa-exclamation-circle"></i> <?php echo $session_message_error; ?>
                    <button type="button" class="close" data-dismiss="alert">&times;</button>
                </div>
            <?php } ?>
            <?php if (!empty($session_message_info)) { ?>
                <div class="alert alert-info"><i class="fa fa-info-circle"></i> <?php echo $session_message_info; ?>
                    <button type="button" class="close" data-dismiss="alert">&times;</button>
                </div>
            <?php } ?>
            <?php if (!empty($session_message_success)) { ?>
                <div class="alert alert-success"><i class="fa fa-check-circle"></i> <?php echo $session_message_success; ?>
                    <button type="button" class="close" data-dismiss="alert">&times;</button>
                </div>
            <?php } ?>

            <div class="panel panel-default">
                <div class="panel-heading">
                    <h3 class="panel-title"><i class="fa fa-pencil"></i> <?php echo $heading_title_2; ?></h3>
                </div>
                <div class="panel-body">
                    <?php if (!empty($form)) { ?>
                        <?= $form ?>
                    <?php } else { ?>
                        <script type="text/javascript">
                            $(function() {
                                $(document).on("keydown", "input#license_id", function (e) {
                                    if (e.which == 13) {
                                        ajax_get_form();
                                        event.preventDefault();
                                        return false;
                                    }
                                });
                            });
                        </script>
                        <div class="license_form_container opencart_<?= $oc_version ?>">
                            <div class="row">
                                <div class="col-md-12">
                                    <form id="license_form">
                                        <h2 class="heading"><?= $text_validate_license ?></h2>
                                        <input type="text" id="license_id" name="license_id" class="form-control" placeholder="<?= $text_license_id ?>" required="" autofocus="" value="<?= $license_id ?>">
                                        <a class="btn btn-lg btn-primary btn-block" onclick="ajax_get_form();return false;"><?= $text_send ?></a>
                                        <?= isset($link_trial) ? $link_trial : '' ?>
                                    </form>
                                </div>
                            </div>
                        </div>
                    <?php } ?>
                </div>
            </div>
        </div>
    </div>

<script type="text/javascript">
    var token = '<?php echo !empty($token) ? $token : ''; ?>';
    var text_none = '<?= !empty($text_none) ? $text_none : 'none'; ?>';
</script>

<?php if(!empty($jquery_variables)) { ?>
    <script type="text/javascript">
        <?php foreach ($jquery_variables as $var_name => $value) {
            $is_numeric = is_numeric($value);
            echo 'var '.$var_name.' = '.(!$is_numeric ? '"':'').htmlspecialchars_decode($value).(!$is_numeric ? '"':'').';'."\n";
        } ?>
    </script>
<?php } ?>

<?php
    if (version_compare(VERSION, '2', '>=')) {
        echo $footer;
    } else { ?>
        </body>
    </html>
<?php } ?>

