<?php

class ControllerPaymentAuthnetsim extends Controller {

    protected $errors = array();

    public function index() {

        # Generic Init
        $extension_type             = 'payment';
        $classname                  = str_replace('vq2-' . basename(DIR_APPLICATION) . '_' . strtolower(get_parent_class($this)) . '_' . $extension_type . '_', '', basename(__FILE__, '.php'));
        $data['classname']          = $classname;
        $data                       = array_merge($data, $this->load->language($extension_type . '/' . $classname));

        # Order Info
        $this->load->model('checkout/order');
        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

        # Error Check
        $data['error'] = (isset($this->session->data['error'])) ? $this->session->data['error'] : NULL;
        unset($this->session->data['error']);

        $data['use_iframe'] = $this->config->get($classname . '_iframe');

        # Check for supported currency, otherwise convert to ISK.
        $supported_currencies = explode(",", $this->config->get($classname . '_supported_currencies'));
        if (in_array($order_info['currency_code'], $supported_currencies)) {
            $currency = $order_info['currency_code'];
        } else {
            $currency = $this->config->get($classname . '_default_currency');
        }

        $amount = number_format($this->currency->format($order_info['total'], $currency, FALSE, FALSE),2, '.', '');
        $cancelurl      = $this->url->link($extension_type . '/' . $classname . '/cancel', '', 'SSL');
        $successurl     = $this->url->link($extension_type . '/' . $classname . '/success', '', 'SSL');
        $callbackurl    = $this->url->link($extension_type . '/' . $classname . '/callback', '', 'SSL');


        // Mijo Support
        if (strpos(DIR_SYSTEM, 'mijo') !== false) {
            $cancelurl = str_replace('route', 'option=com_mijoshop&format=raw&tmpl=component&route', $cancelurl);
            $successurl = str_replace('route', 'option=com_mijoshop&format=raw&tmpl=component&route', $successurl);
            $callbackurl = str_replace('route', 'option=com_mijoshop&format=raw&tmpl=component&route', $callbackurl);
        }

        // As of 2015-09-07, Authnet no longer supports ? and & in their relay response urls
        // Must use a redirect script instead
        $callbackurl    = HTTP_SERVER . 'authnetsim_callback.php';

        $sequence = rand(1, 1000);
        $xlogin = trim($this->config->get($classname . '_mid'));
        $xtxnkey = trim($this->config->get($classname . '_key'));

        $data['fields'] = array();
        $data['fields']['x_version']                = '3.0';
        $data['fields']['x_method']                 = 'CC';
        $data['fields']['x_login']              = $xlogin;
        $data['fields']['x_amount']                 = $amount;
        $data['fields']['x_currency_code']      = $currency;
        $data['fields']['x_type']               = 'auth_only'; //($this->config->get($classname . '_type') == '0' ? 'auth_only' : 'auth_capture');
        $data['fields']['x_cust_ID']                = $order_info['customer_id'];
        $data['fields']['x_email_customer']         = ($this->config->get($classname . '_mail') == '1' ? 'TRUE': 'FALSE');
        $data['fields']['x_company']                = $order_info['payment_company'];
        $data['fields']['x_first_name']             = $order_info['payment_firstname'];
        $data['fields']['x_last_name']          = $order_info['payment_lastname'];
        //$data['fields']['x_address']              = $order_info['payment_address_1'] . ' ' . $order_info['payment_address_2'];
        if (stripos($order_info['payment_address_1'], 'box ') === false) {
            $data['fields']['x_address']            = $order_info['payment_address_1'] . $order_info['payment_address_2'];
        } else {
            $data['fields']['x_address']            = $order_info['payment_address_1'];
        }
        $data['fields']['x_city']               = $order_info['payment_city'];
        $data['fields']['x_state']              = $order_info['payment_zone'];
        $data['fields']['x_state']              = $order_info['payment_zone'];
        $data['fields']['x_zip']                    = $order_info['payment_postcode'];
        $data['fields']['x_country']                = $order_info['payment_country'];
        $data['fields']['x_phone']              = $order_info['telephone'];
        $data['fields']['x_fax']                    = $order_info['fax'];
        $data['fields']['x_email']              = $order_info['email'];
        $data['fields']['x_ship_to_company']        = $order_info['shipping_company'];
        $data['fields']['x_ship_to_first_name']     = $order_info['shipping_firstname'];
        $data['fields']['x_ship_to_last_name']  = $order_info['shipping_lastname'];
        //$data['fields']['x_ship_to_address']      = $order_info['shipping_address_1'] . ' ' . $order_info['shipping_address_2'];
        if (stripos($order_info['shipping_address_1'], 'box ') === false) {
            $data['fields']['x_ship_to_address']    = $order_info['shipping_address_1'] . $order_info['shipping_address_2'];
        } else {
            $data['fields']['x_ship_to_address']    = $order_info['shipping_address_1'];
        }
        $data['fields']['x_ship_to_city']       = $order_info['shipping_city'];
        $data['fields']['x_ship_to_state']      = $order_info['shipping_zone'];
        $data['fields']['x_ship_to_zip']            = $order_info['shipping_postcode'];
        $data['fields']['x_ship_to_country']        = $order_info['shipping_country'];
        $data['fields']['x_Customer_IP']            = $order_info['ip'];
        $data['fields']['x_invoice_num']            = $order_info['order_id'];
        $data['fields']['x_description']            = 'Online purchase from ' . str_replace('"',"'", (($this->config->get('config_name')) ? $this->config->get('config_name') : $this->config->get('config_store')));
        $data['fields']['x_duplicate_window']   = '120';
        $data['fields']['x_relay_response']         = 'TRUE';
        $data['fields']['x_relay_always']       = 'TRUE';
        $data['fields']['x_relay_url']          = $callbackurl;
        $data['fields']['x_show_form']          = 'PAYMENT_FORM';
        $data['fields']['x_cancel_url']         = $cancelurl;
        $data['fields']['x_cancel_url_text']        = $this->language->get('text_'.$classname.'_cancel_msg');
        $data['fields']['x_receipt_link_method']    = 'POST';
        $data['fields']['x_receipt_link_text']  = $this->language->get('text_'.$classname.'_return_msg');
        $data['fields']['x_receipt_link_url']   = $successurl;
        $data['fields']['x_logo_url']           = $this->config->get($classname . '_logo');

        $form_security_array = $this->InsertFP($xlogin, $xtxnkey, number_format(str_replace(',', '', $this->currency->format($order_info['total'], $currency, FALSE, FALSE)), 2,'.',''), $sequence, $currency);

        foreach ($form_security_array as $k => $v) {
            $data['fields'][$k] = $v;
        }

        if ($this->config->get($classname . '_test') == 'dev') {
            if ($this->config->get($classname . '_dev_server') !== "") {
                $data['action'] = trim($this->config->get($classname . '_dev_server'));
            } else {
                $data['action'] = 'https://test.authorize.net/gateway/transact.dll';
            }
            $data['testmode'] = 1; // Force test mode
            $data['fields']['x_test_request'] = 'TRUE';
        } elseif ($this->config->get($classname . '_test') == 'test') {
            if ($this->config->get($classname . '_live_server') !== "") {
                $data['action'] = trim($this->config->get($classname . '_live_server'));
            } else {
                $data['action'] = 'https://secure.authorize.net/gateway/transact.dll';
            }
            $data['testmode'] = 1; // Force test mode
            $data['fields']['x_test_request'] = 'TRUE';
        } else { // live
            if ($this->config->get($classname . '_live_server') !== "") {
                $data['action'] = trim($this->config->get($classname . '_live_server'));
            } else {
                $data['action'] = 'https://secure.authorize.net/gateway/transact.dll';
            }
            $data['testmode'] = 0;
        }

        $data['error']          =(isset($this->session->data['error'])) ? $this->session->data['error'] : NULL;
        unset($this->session->data['error']);

        // Debug
        if ($this->config->get($classname . '_debug')) { file_put_contents(DIR_LOGS . $classname . '_debug.txt', __FUNCTION__ . "\r\n$classname FIELDS: " . print_r($data['fields'],1) . "\r\n"); }


        # Compatibility
        if (version_compare(VERSION, '2.0', '>=')) { // v2.0.x Compatibility
            if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/' . $extension_type . '/'. $classname . '.tpl')) {
                return $this->load->view($this->config->get('config_template') . '/template/' . $extension_type . '/'. $classname . '.tpl', $data);
            } else {
                return $this->load->view('default/template/' . $extension_type . '/'. $classname . '.tpl', $data);
            }
        } elseif (version_compare(VERSION, '2.0', '<')) {  // 1.5.x Backwards Compatibility
            $this->data = array_merge($this->data, $data);
            $this->id   = 'payment';
            if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/' . $classname . '.tpl')) {
                $this->template = $this->config->get('config_template') . '/template/payment/' . $classname . '.tpl';
            } else {
                $this->template = 'default/template/payment/' . $classname . '.tpl';
            }
            $this->render();
        }
    }

    public function success() {
        $classname = str_replace('vq2-catalog_controller_payment_', '', basename(__FILE__, '.php'));
        $successurl = $this->url->link('checkout/success', '', 'SSL');
        // Mijo Support
        if (strpos(DIR_SYSTEM, 'mijo') !== false) {
            $successurl = str_replace('route', 'option=com_mijoshop&format=raw&tmpl=component&route', $successurl);
        }
        echo '<script language="text/javascript">parent.location="'. $successurl . '"</script>';
        exit;
    }

    public function cancel() {
        $classname = str_replace('vq2-catalog_controller_payment_', '', basename(__FILE__, '.php'));
        $cancelurl = $this->url->link('checkout/cart', '', 'SSL');
        // Mijo Support
        if (strpos(DIR_SYSTEM, 'mijo') !== false) {
            $cancelurl = str_replace('route', 'option=com_mijoshop&format=raw&tmpl=component&route', $cancelurl);
        }
        echo '<script language="text/javascript">parent.location="'. $cancelurl . '"</script>';
        exit;
    }

    private function fail($msg = false) {
        $failurl = $this->url->link('checkout/cart');
        // Mijo Support
        if (strpos(DIR_SYSTEM, 'mijo') !== false) {
            $failurl = str_replace('route', 'option=com_mijoshop&format=raw&tmpl=component&route', $failurl);
        }
        if (!$msg) { $msg = (!empty($this->session->data['error']) ? $this->session->data['error'] : 'Unknown Error'); }
        echo '<html><head><script type="text/javascript">';
        echo 'alert("'.addslashes($msg).'");';
        echo 'window.location="' . $failurl . '";';
        echo '</script></head></html>';
        exit;
    }

    public function callback() {
        # Generic Init
        $extension_type             = 'payment';
        $classname                  = str_replace('vq2-' . basename(DIR_APPLICATION) . '_' . strtolower(get_parent_class($this)) . '_' . $extension_type . '_', '', basename(__FILE__, '.php'));
        $data['classname']          = $classname;
        $data                       = array_merge($data, $this->load->language($extension_type . '/' . $classname));

        // Debug
        if ($this->config->get($classname . '_debug')) { file_put_contents(DIR_LOGS . $classname . '_debug.txt', __FUNCTION__ . "\r\n$classname GET: " . print_r($_GET,1) . "\r\n" . "$classname POST: " . print_r($_POST,1) . "\r\n", FILE_APPEND); }

        if (isset($_REQUEST['x_invoice_num'])) {
            $order_id = $_REQUEST['x_invoice_num'];
        } else {
            $order_id = 0;
        }

        $this->load->model('checkout/order');
        $order_info = $this->model_checkout_order->getOrder($order_id);

        // If there is no order info then fail.
        if (!$order_info) {
            $this->session->data['error'] = $this->language->get('error_no_order');
            $this->fail();
        }

        if (isset($_REQUEST['x_response_code']) && $_REQUEST['x_response_code'] == '1') {

            $msg = print_r($_REQUEST, 1);
            if (method_exists($this->model_checkout_order, 'addOrderHistory')) { // v20x
                $this->model_checkout_order->addOrderHistory($order_id, $this->config->get('config_order_status_id'), $order_info['comment'], true);
                $this->model_checkout_order->addOrderHistory($order_id, $this->config->get($classname . '_order_status_id'), FALSE, false);
            } else { //v15x
                $this->model_checkout_order->confirm($order_id, $this->config->get('config_order_status_id'), $order_info['comment']);
                $this->model_checkout_order->update($order_id, $this->config->get($classname . '_order_status_id'), FALSE, FALSE);
            }

            $successurl = $this->url->link('checkout/success', '', 'SSL');
            // Mijo Support
            if (strpos(DIR_SYSTEM, 'mijo') !== false) {
                $successurl = str_replace('route', 'option=com_mijoshop&format=raw&tmpl=component&route', $successurl);
            }
            $relayhtml  = '<html><head><base target="_top"><script language="Javascript">parent.location="'. $successurl . '"</script>';
            $relayhtml .= '</head><body><a href="'.$successurl.'">--></a></body></html>';
            print $relayhtml;
            exit;
        } else {
            $this->session->data['error'] = $_REQUEST['x_response_reason_text'];
            $this->fail();
        }
    }

    // Begin Authorize.net supplied code
    // DISCLAIMER:
    //     This code is distributed in the hope that it will be useful, but without any warranty;
    //     without even the implied warranty of merchantability or fitness for a particular purpose.

    // Main Interfaces:
    //
    // function InsertFP ($loginid, $x_tran_key, $amount, $sequence) - Insert HTML form elements required for SIM
    // function CalculateFP ($loginid, $x_tran_key, $amount, $sequence, $tstamp) - Returns Fingerprint.


    // compute HMAC-MD5
    // Uses PHP mhash extension. Pl sure to enable the extension
    //function hmac ($key, $data)
    //{
    //return (bin2hex (mhash(MHASH_MD5, $data, $key)));
    //}

    function hmac ($key, $data) {
       // RFC 2104 HMAC implementation for php.
       // Creates an md5 HMAC.
       // Eliminates the need to install mhash to compute a HMAC
       // Hacked by Lance Rushing
       $b = 64; // byte length for md5
       if (strlen($key) > $b) {
           $key = pack("H*",md5($key));
       }
       $key  = str_pad($key, $b, chr(0x00));
       $ipad = str_pad('', $b, chr(0x36));
       $opad = str_pad('', $b, chr(0x5c));
       $k_ipad = $key ^ $ipad ;
       $k_opad = $key ^ $opad;
       return md5($k_opad  . pack("H*",md5($k_ipad . $data)));
    }

    // Calculate and return fingerprint
    // Use when you need control on the HTML output
    function CalculateFP ($loginid, $x_tran_key, $amount, $sequence, $tstamp, $currency = "") {
        return ($this->hmac ($x_tran_key, $loginid . "^" . $sequence . "^" . $tstamp . "^" . $amount . "^" . $currency));
    }

    // Inserts the hidden variables in the HTML FORM required for SIM
    // Invokes hmac function to calculate fingerprint.

    function InsertFP ($loginid, $x_tran_key, $amount, $sequence, $currency = "") {
        $tstamp = time ();
        $fingerprint = $this->hmac ($x_tran_key, $loginid . "^" . $sequence . "^" . $tstamp . "^" . $amount . "^" . $currency);

        $security_array = array('x_fp_sequence' => $sequence,
                                'x_fp_timestamp' => $tstamp,
                                'x_fp_hash' => $fingerprint);
        return $security_array;
    }



}
?>