<?php
class ModelTotalSocialDiscountsTotal extends Model {
	public function getTotal(&$total_data, &$total, &$taxes) {
		
		if (!empty($this->session->data['socialdiscounts']['actions'])) {
			$discount_total = 0; 
			$discounts = $this->session->data['socialdiscounts']['actions'];
			$this->language->load('total/socialdiscountsTotal');
			
			$moduleSettings = $this->config->get('socialdiscounts');

			if (isset($moduleSettings['basic']['value']) && $moduleSettings['basic']['value']=='0') {
				foreach ($discounts as $key => $discount) {		
					$sub_total = $this->cart->getSubTotal();
	
					if ($discount['type'] == 'F') {
						$discount['discount'] = min($discount['discount'], $sub_total);
					}
					$current_discount = 0;
					foreach ($this->cart->getProducts() as $product) {
						$product_discount = 0;
	
						if ($discount['type'] == 'F') {
							$product_discount = $discount['discount'] * ($product['total'] / $sub_total);
						} elseif ($discount['type'] == 'P') {
							$product_discount = $product['total'] / 100 * $discount['discount'];
						} 
						if ($product['tax_class_id']) {
							$tax_rates = $this->tax->getRates($product['total'] - ($product['total'] - $product_discount), $product['tax_class_id']);
							foreach ($tax_rates as $tax_rate) {
								if ($tax_rate['type'] == 'P') {
									$taxes[$tax_rate['tax_rate_id']] -= $tax_rate['amount'];
								}
							}
						}
						$current_discount += $product_discount;
					}
					$discount_total += $current_discount;
				}
			} else {
				$sub_total = $this->cart->getSubTotal();

				if ($moduleSettings['basic']['type'] == 'F') {
					$moduleSettings['basic']['value'] = min($moduleSettings['basic']['value'], $sub_total);
				}
				$current_discount = 0;
				foreach ($this->cart->getProducts() as $product) {
					$product_discount = 0;
					if ($moduleSettings['basic']['type'] == 'F') {
						$product_discount = $moduleSettings['basic']['value'] * ($product['total'] / $sub_total);
					} elseif ($moduleSettings['basic']['type'] == 'P') {
						$product_discount = $product['total'] / 100 * $moduleSettings['basic']['value'];
					} 
					if ($product['tax_class_id']) {
						$tax_rates = $this->tax->getRates($product['total'] - ($product['total'] - $product_discount), $product['tax_class_id']);
						foreach ($tax_rates as $tax_rate) {
							if ($tax_rate['type'] == 'P') {
								$taxes[$tax_rate['tax_rate_id']] -= $tax_rate['amount'];
							}
						}
					}
					$current_discount += $product_discount;
				}
				$discount_total += $current_discount;
			}
			
			$total -= $discount_total;
			$actions = array();
			if(isset($this->session->data['socialdiscounts']['actions'])){
					
				foreach ($this->session->data['socialdiscounts']['actions'] as $key => $value) {
					$actions[] = $key;
				}
			}
			$total_data[] = array(
				'code'       => 'socialdiscountsTotal',
				'title'      => sprintf($this->language->get('text_socialdiscounts'), implode(',', $actions)),
				'text'       => $this->currency->format(-$discount_total),
				'value'      => -$discount_total,
				'sort_order' => $this->config->get('socialdiscountsTotal_sort_order')
			); 
		}
	}
}
?>