<!DOCTYPE html>
<html dir="<?php echo $direction; ?>" lang="<?php echo $lang; ?>">
<head>
<meta charset="UTF-8" />
<title><?php echo $title; ?></title>
<base href="<?php echo $base; ?>" />
<?php if ($description) { ?>
<meta name="description" content="<?php echo $description; ?>" />
<?php } ?>
<?php if ($keywords) { ?>
<meta name="keywords" content="<?php echo $keywords; ?>" />
<?php } ?>
<?php if ($icon) { ?>
<link href="<?php echo $icon; ?>" rel="icon" />
<?php } ?>
<?php foreach ($links as $link) { ?>
<link href="<?php echo $link['href']; ?>" rel="<?php echo $link['rel']; ?>" />
<?php } ?>
<link rel="stylesheet" type="text/css" href="catalog/view/theme/default/stylesheet/stylesheet.css" />
<?php foreach ($styles as $style) { ?>
<link rel="<?php echo $style['rel']; ?>" type="text/css" href="<?php echo $style['href']; ?>" media="<?php echo $style['media']; ?>" />
<?php } ?>
<script type="text/javascript" src="catalog/view/javascript/jquery/jquery-1.7.1.min.js"></script>
<script type="text/javascript" src="catalog/view/javascript/jquery/ui/jquery-ui-1.8.16.custom.min.js"></script>
<link rel="stylesheet" type="text/css" href="catalog/view/javascript/jquery/ui/themes/ui-lightness/jquery-ui-1.8.16.custom.css" />
<script type="text/javascript" src="catalog/view/javascript/common.js"></script>
<?php foreach ($scripts as $script) { ?>
<script type="text/javascript" src="<?php echo $script; ?>"></script>
<?php } ?>
<!--[if IE 7]> 
<link rel="stylesheet" type="text/css" href="catalog/view/theme/default/stylesheet/ie7.css" />
<![endif]-->
<!--[if lt IE 7]>
<link rel="stylesheet" type="text/css" href="catalog/view/theme/default/stylesheet/ie6.css" />
<script type="text/javascript" src="catalog/view/javascript/DD_belatedPNG_0.0.8a-min.js"></script>
<script type="text/javascript">
DD_belatedPNG.fix('#logo img');
</script>
<![endif]-->
<?php if ($stores) { ?>
<script type="text/javascript"><!--
$(document).ready(function() {
<?php foreach ($stores as $store) { ?>
$('body').prepend('<iframe src="<?php echo $store; ?>" style="display: none;"></iframe>');
<?php } ?>
});
//--></script>
<?php } ?>
<?php echo $google_analytics; ?>

            <style type="text/css">
            .otip_trigger{
                cursor:pointer;
                width:16px;
                height:16px;
                display:inline;
                float:right;
            }
            .otip {
                display:block;
                position:fixed;
                z-index:1000;
                background-color:#fef9b7;
                width:280px;
                padding:15px;
                font-size:90%;
                -webkit-border-radius: 3px;
                -moz-border-radius: 3px;
                border-radius: 3px;
                -moz-box-shadow:5px 5px 15px 0px rgba(162, 162, 162, 0.4);
                -webkit-box-shadow:5px 5px 15px 0px rgba(162, 162, 162, 0.4);
                box-shadow:5px 5px 15px 0px rgba(162, 162, 162, 0.4);
                border:1px solid #dddddd;
            }

            .tt {
                display:inline;
                position:relative;
            }


            .tt span {
                cursor:pointer;
                display:inline-block;
                outline:none;
                position:relative;
                text-decoration:none;
            }

            .tt span i {
                width: 250px;
                visibility:hidden;
                border:1px solid #444;
                bottom:60px;
                left:50%;
                margin-left:-250px;
                opacity:0;
                padding:10px;
                position:absolute;

                z-index:1100;
                font-style:normal;


                background-color: #eee;

                -webkit-border-radius:5px;
                -moz-border-radius:5px;
                -ms-border-radius:5px;
                -o-border-radius:5px;
                border-radius:5px;

                -webkit-transition:all 0.3s ease-in-out;
                -moz-transition:all 0.3s ease-in-out;
                -o-transition:all 0.3s ease-in-out;
                -ms-transition:all 0.3s ease-in-out;
                transition:all 0.3s ease-in-out;
            }
            .tt span:hover i {
                bottom:30px;
                opacity:1;
                visibility:visible;
            }


            </style>
            <script type="text/javascript">
            $(document).ready(function() {
                //Tooltips
                $(".otip_trigger").hover(function(){
                    otip = $(this).find('.otip');

                    otip.stop(true, true).fadeIn();
                    console.log("Hover");
                    //tip.show(); //Show tooltip
                }, function() {
                    otip.stop(true, true).fadeOut();
                    //tip.hide(); //Hide tooltip
                }).mousemove(function(e) {
                    //var mousex = e.clientX + 20; //Get X coodrinates
                    //var mousey = e.clientY + 20; //Get Y coordinates

                    var mousex = $(".otip_trigger").clientX - 20; //Get X coodrinates
                    var mousey = $(".otip_trigger").clientY + 20; //Get Y coordinates

                    var tipWidth = otip.width(); //Find width of tooltip
                    var tipHeight = otip.height(); //Find height of tooltip

                    var main_container = $('div.main-container');

                    //Distance of element from the right edge of viewport
                    var tipVisX = main_container - (mousex + tipWidth);

                    console.log("VisX: " + tipVisX);
                    //Distance of element from the bottom of viewport
                    var tipVisY = $(window).height() - (mousey + tipHeight);

                    if ( tipVisX < 20 ) { //If tooltip exceeds the X coordinate of viewport
                        mousex = e.clientX - tipWidth - 20;
                        //mousex = e.clientX - 20;
                    } if ( tipVisY < 20 ) { //If tooltip exceeds the Y coordinate of viewport
                        mousey = e.clientY - tipHeight - 20;
                    }
                    //Absolute position the tooltip according to mouse position
                    otip.css({  top: mousey, left: mousex });
                });
            });
            </script>
        
</head>
<body>
<div id="container">
<div id="header">
  <?php if ($logo) { ?>
  <div id="logo"><a href="<?php echo $home; ?>"><img src="<?php echo $logo; ?>" title="<?php echo $name; ?>" alt="<?php echo $name; ?>" /></a></div>
  <?php } ?>
  <?php echo $language; ?>
  <?php echo $currency; ?>
  <?php echo $cart; ?>
  <div id="search">
    <div class="button-search"></div>
    <input type="text" name="search" placeholder="<?php echo $text_search; ?>" value="<?php echo $search; ?>" />
  </div>
  <div id="welcome">
    <?php if (!$logged) { ?>
    <?php echo $text_welcome; ?>
    <?php } else { ?>
    <?php echo $text_logged; ?>
    <?php } ?>
  </div>
  <div class="links"><a href="<?php echo $home; ?>"><?php echo $text_home; ?></a><a href="<?php echo $wishlist; ?>" id="wishlist-total"><?php echo $text_wishlist; ?></a><a href="<?php echo $account; ?>"><?php echo $text_account; ?></a><a href="<?php echo $shopping_cart; ?>"><?php echo $text_shopping_cart; ?></a><a href="<?php echo $checkout; ?>"><?php echo $text_checkout; ?></a></div>
</div>
<?php if ($categories) { ?>
<div id="menu">
  <ul>
    <?php foreach ($categories as $category) { ?>
    <li><a href="<?php echo $category['href']; ?>"><?php echo $category['name']; ?></a>
      <?php if ($category['children']) { ?>
      <div>
        <?php for ($i = 0; $i < count($category['children']);) { ?>
        <ul>
          <?php $j = $i + ceil(count($category['children']) / $category['column']); ?>
          <?php for (; $i < $j; $i++) { ?>
          <?php if (isset($category['children'][$i])) { ?>
          <li><a href="<?php echo $category['children'][$i]['href']; ?>"><?php echo $category['children'][$i]['name']; ?></a></li>
          <?php } ?>
          <?php } ?>
        </ul>
        <?php } ?>
      </div>
      <?php } ?>
    </li>
    <?php } ?>
  </ul>
</div>
<?php } ?>
<div id="notification"></div>
