<!DOCTYPE html>
<?php
    if (!defined('JOURNAL_INSTALLED')) {
        echo '
            <h3>Journal Installation Error</h3>
            <p>Make sure you have uploaded all Journal files to your server and successfully replaced <b>system/engine/front.php</b> file.</p>
            <p>You can find more information <a href="http://docs.digital-atelier.com/opencart/journal/#/settings/install" target="_blank">here</a>.</p>
        ';
        exit();
    }
?>
<html dir="<?php echo $direction; ?>" lang="<?php echo $lang; ?>" class="<?php echo $this->journal2->html_classes->getAll(); ?>" data-j2v="<?php echo JOURNAL_VERSION; ?>">
<head>
<meta charset="UTF-8" />
<?php if ($this->journal2->settings->get('responsive_design')): ?>
<meta name="viewport" content="width=device-width, initial-scale=1, minimum-scale=1, maximum-scale=1, user-scalable=no">
<?php endif; ?>
<meta name="format-detection" content="telephone=no">
<!--[if IE]><meta http-equiv="X-UA-Compatible" content="IE=Edge,chrome=1"/><![endif]-->
<!--[if lt IE 9]><script src="//ie7-js.googlecode.com/svn/version/2.1(beta4)/IE9.js"></script><![endif]-->
<title><?php echo $title; ?></title>
<base href="<?php echo $base; ?>" />
<?php if ($meta_title = $this->journal2->settings->get('blog_meta_title')): ?>
<meta name="title" content="<?php echo $meta_title; ?>" />
<?php endif; ?>
<?php if ($description) { ?>
<meta name="description" content="<?php echo $description; ?>" />
<?php } ?>
<?php if ($keywords) { ?>
<meta name="keywords" content="<?php echo $keywords; ?>" />
<?php } ?>
<?php foreach ($this->journal2->settings->get('share_metas', array()) as $sm): ?>
<meta property="<?php echo $sm['type']; ?>" content="<?php echo $sm['content']; ?>" />
<?php endforeach ;?>
<?php if ($icon) { ?>
<link href="<?php echo $icon; ?>" rel="icon" />
<?php } ?>
<?php if ($blog_feed_url = $this->journal2->settings->get('blog_blog_feed_url')): ?>
<link rel="alternate" type="application/rss+xml" title="RSS" href="<?php echo $blog_feed_url; ?>" />
<?php endif; ?>
<?php foreach ($links as $link) { ?>
<link href="<?php echo $link['href']; ?>" rel="<?php echo $link['rel']; ?>" />
<?php } ?>
<?php foreach ($styles as $style) { ?>
<?php $this->journal2->minifier->addStyle($style['href']); ?>
<?php } ?>
<?php foreach ($this->journal2->google_fonts->getFonts() as $font): ?>
<link rel="stylesheet" href="<?php echo $font; ?>"/>
<?php endforeach; ?>
<?php foreach ($scripts as $script) { ?>
<?php $this->journal2->minifier->addScript($script, 'header'); ?>
<?php } ?>
<?php
    $this->journal2->minifier->addStyle('catalog/view/theme/journal2/css/hint.min.css');
    $this->journal2->minifier->addStyle('catalog/view/theme/journal2/css/journal.css');
    $this->journal2->minifier->addStyle('catalog/view/theme/journal2/css/features.css');
    $this->journal2->minifier->addStyle('catalog/view/theme/journal2/css/header.css');
    $this->journal2->minifier->addStyle('catalog/view/theme/journal2/css/module.css');
    $this->journal2->minifier->addStyle('catalog/view/theme/journal2/css/pages.css');
    $this->journal2->minifier->addStyle('catalog/view/theme/journal2/css/account.css');
    $this->journal2->minifier->addStyle('catalog/view/theme/journal2/css/blog-manager.css');
    $this->journal2->minifier->addStyle('catalog/view/theme/journal2/css/side-column.css');
    $this->journal2->minifier->addStyle('catalog/view/theme/journal2/css/product.css');
    $this->journal2->minifier->addStyle('catalog/view/theme/journal2/css/category.css');
    $this->journal2->minifier->addStyle('catalog/view/theme/journal2/css/footer.css');
    $this->journal2->minifier->addStyle('catalog/view/theme/journal2/css/icons.css');


    if ($this->journal2->settings->get('responsive_design')) {
        $this->journal2->minifier->addStyle('catalog/view/theme/journal2/css/responsive.css');
    }

    $this->journal2->minifier->addStyle('catalog/view/theme/journal2/css/throttlejockey.css');
    $this->journal2->minifier->addStyle('catalog/view/theme/journal2/css/social-bar.css');

?>
<?php echo $this->journal2->minifier->css(); ?>
<?php if ($this->journal2->cache->getDeveloperMode() || !$this->journal2->minifier->getMinifyCss()): ?>
<link rel="stylesheet" href="index.php?route=journal2/assets/css&amp;j2v=<?php echo JOURNAL_VERSION; ?>" />
<?php endif; ?>
<?php $this->journal2->minifier->addScript('catalog/view/theme/journal2/js/journal.js', 'header'); ?>
<?php $this->journal2->minifier->addScript('catalog/view/theme/journal2/js/social-bar.js', 'header'); ?>


<?php echo $this->journal2->minifier->js('header'); ?>
<!--[if (gte IE 6)&(lte IE 8)]><script src="catalog/view/theme/journal2/lib/selectivizr/selectivizr.min.js"></script><![endif]-->
<?php if (isset($stores)): /* v1541 compatibility */ ?>
<?php if ($stores) { ?>
<script type="text/javascript"><!--
$(document).ready(function() {
<?php foreach ($stores as $store) { ?>
$('body').prepend('<iframe src="<?php echo $store; ?>" style="display: none;"></iframe>');
<?php } ?>
});
//--></script>
<?php } ?>
<?php endif; /* end v1541 compatibility */ ?>
<?php echo $google_analytics; ?>
<script>
    <?php if ($this->journal2->settings->get('show_countdown', 'never') !== 'never' || $this->journal2->settings->get('show_countdown_product_page', 'on') == 'on'): ?>
    Journal.COUNTDOWN = {
        DAYS    : "<?php echo $this->journal2->settings->get('countdown_days', 'Days'); ?>",
        HOURS   : "<?php echo $this->journal2->settings->get('countdown_hours', 'Hours'); ?>",
        MINUTES : "<?php echo $this->journal2->settings->get('countdown_min', 'Min'); ?>",
        SECONDS : "<?php echo $this->journal2->settings->get('countdown_sec', 'Sec'); ?>"
    };
    <?php endif; ?>
    Journal.NOTIFICATION_BUTTONS = '<?php echo $this->journal2->settings->get('notification_buttons'); ?>';
</script>

<script type="text/javascript" src="catalog/view/javascript/jquery/colorbox/jquery.colorbox.js"></script>
<link rel="stylesheet" type="text/css" href="catalog/view/javascript/jquery/colorbox/colorbox.css" media="screen" />

<!-- jQuery Popup Overlay -->
<script src="catalog/view/javascript/jquery.popupoverlay.js"></script>
<style>
    .well {
        -webkit-transform: scale(0.8);
           -moz-transform: scale(0.8);
            -ms-transform: scale(0.8);
                transform: scale(0.8);
    }
    .popup_visible .well {
        -webkit-transform: scale(1);
           -moz-transform: scale(1);
            -ms-transform: scale(1);
                transform: scale(1);
                background-color: #ffffff;
                padding: 15px;
                border-radius: 10px;
    }
</style>
            <style type="text/css">
            .otip_trigger{
                cursor:pointer;
                width:16px;
                height:16px;
                display:inline;
                float:right;
            }
            .otip {
                display:block;
                position:fixed;
                z-index:1000;
                background-color:#fef9b7;
                width:280px;
                padding:15px;
                font-size:90%;
                -webkit-border-radius: 3px;
                -moz-border-radius: 3px;
                border-radius: 3px;
                -moz-box-shadow:5px 5px 15px 0px rgba(162, 162, 162, 0.4);
                -webkit-box-shadow:5px 5px 15px 0px rgba(162, 162, 162, 0.4);
                box-shadow:5px 5px 15px 0px rgba(162, 162, 162, 0.4);
                border:1px solid #dddddd;
            }

            .tt {
                display:inline;
                position:relative;
            }


            .tt span {
                cursor:pointer;
                display:inline-block;
                outline:none;
                position:relative;
                text-decoration:none;
            }

            .tt span i {
                width: 250px;
                visibility:hidden;
                border:1px solid #444;
                bottom:60px;
                left:50%;
                margin-left:-250px;
                opacity:0;
                padding:10px;
                position:absolute;

                z-index:1100;
                font-style:normal;


                background-color: #eee;

                -webkit-border-radius:5px;
                -moz-border-radius:5px;
                -ms-border-radius:5px;
                -o-border-radius:5px;
                border-radius:5px;

                -webkit-transition:all 0.3s ease-in-out;
                -moz-transition:all 0.3s ease-in-out;
                -o-transition:all 0.3s ease-in-out;
                -ms-transition:all 0.3s ease-in-out;
                transition:all 0.3s ease-in-out;
            }
            .tt span:hover i {
                bottom:30px;
                opacity:1;
                visibility:visible;
            }

            .option_heading b {
                display: inline-block !important;
            }


/* Change style of select boxes */
.options select {
  font-size: 14px;
  height: 34px;
  width: 80%;
}

            </style>

            <script type="text/javascript">
            $(document).ready(function() {
                //Tooltips
                $(".otip_trigger").hover(function(){
                    otip = $(this).find('.otip');

                    otip.stop(true, true).fadeIn();
                    console.log("Hover");
                    //tip.show(); //Show tooltip
                }, function() {
                    otip.stop(true, true).fadeOut();
                    //tip.hide(); //Hide tooltip
                }).mousemove(function(e) {
                    //var mousex = e.clientX + 20; //Get X coodrinates
                    //var mousey = e.clientY + 20; //Get Y coordinates

                    var mousex = $(".otip_trigger").clientX - 20; //Get X coodrinates
                    var mousey = $(".otip_trigger").clientY + 20; //Get Y coordinates

                    var tipWidth = otip.width(); //Find width of tooltip
                    var tipHeight = otip.height(); //Find height of tooltip

                    var main_container = $('div.main-container');

                    //Distance of element from the right edge of viewport
                    var tipVisX = main_container - (mousex + tipWidth);

                    console.log("VisX: " + tipVisX);
                    //Distance of element from the bottom of viewport
                    var tipVisY = $(window).height() - (mousey + tipHeight);

                    if ( tipVisX < 20 ) { //If tooltip exceeds the X coordinate of viewport
                        mousex = e.clientX - tipWidth - 20;
                        //mousex = e.clientX - 20;
                    } if ( tipVisY < 20 ) { //If tooltip exceeds the Y coordinate of viewport
                        mousey = e.clientY - tipHeight - 20;
                    }
                    //Absolute position the tooltip according to mouse position
                    otip.css({  top: mousey, left: mousex });
                });
            });
            </script>



            <style type="text/css">
            .otip_trigger{
                cursor:pointer;
                width:16px;
                height:16px;
                display:inline;
                float:right;
            }
            .otip {
                display:block;
                position:fixed;
                z-index:1000;
                background-color:#fef9b7;
                width:280px;
                padding:15px;
                font-size:90%;
                -webkit-border-radius: 3px;
                -moz-border-radius: 3px;
                border-radius: 3px;
                -moz-box-shadow:5px 5px 15px 0px rgba(162, 162, 162, 0.4);
                -webkit-box-shadow:5px 5px 15px 0px rgba(162, 162, 162, 0.4);
                box-shadow:5px 5px 15px 0px rgba(162, 162, 162, 0.4);
                border:1px solid #dddddd;
            }

            .tt {
                display:inline;
                position:relative;
            }


            .tt span {
                cursor:pointer;
                display:inline-block;
                outline:none;
                position:relative;
                text-decoration:none;
            }

            .tt span i {
                width: 250px;
                visibility:hidden;
                border:1px solid #444;
                bottom:60px;
                left:50%;
                margin-left:-250px;
                opacity:0;
                padding:10px;
                position:absolute;

                z-index:1100;
                font-style:normal;


                background-color: #eee;

                -webkit-border-radius:5px;
                -moz-border-radius:5px;
                -ms-border-radius:5px;
                -o-border-radius:5px;
                border-radius:5px;

                -webkit-transition:all 0.3s ease-in-out;
                -moz-transition:all 0.3s ease-in-out;
                -o-transition:all 0.3s ease-in-out;
                -ms-transition:all 0.3s ease-in-out;
                transition:all 0.3s ease-in-out;
            }
            .tt span:hover i {
                bottom:30px;
                opacity:1;
                visibility:visible;
            }


            </style>
            <script type="text/javascript">
            $(document).ready(function() {
                //Tooltips
                $(".otip_trigger").hover(function(){
                    otip = $(this).find('.otip');

                    otip.stop(true, true).fadeIn();
                    console.log("Hover");
                    //tip.show(); //Show tooltip
                }, function() {
                    otip.stop(true, true).fadeOut();
                    //tip.hide(); //Hide tooltip
                }).mousemove(function(e) {
                    //var mousex = e.clientX + 20; //Get X coodrinates
                    //var mousey = e.clientY + 20; //Get Y coordinates

                    var mousex = $(".otip_trigger").clientX - 20; //Get X coodrinates
                    var mousey = $(".otip_trigger").clientY + 20; //Get Y coordinates

                    var tipWidth = otip.width(); //Find width of tooltip
                    var tipHeight = otip.height(); //Find height of tooltip

                    var main_container = $('div.main-container');

                    //Distance of element from the right edge of viewport
                    var tipVisX = main_container - (mousex + tipWidth);

                    console.log("VisX: " + tipVisX);
                    //Distance of element from the bottom of viewport
                    var tipVisY = $(window).height() - (mousey + tipHeight);

                    if ( tipVisX < 20 ) { //If tooltip exceeds the X coordinate of viewport
                        mousex = e.clientX - tipWidth - 20;
                        //mousex = e.clientX - 20;
                    } if ( tipVisY < 20 ) { //If tooltip exceeds the Y coordinate of viewport
                        mousey = e.clientY - tipHeight - 20;
                    }
                    //Absolute position the tooltip according to mouse position
                    otip.css({  top: mousey, left: mousex });
                });
            });
            </script>
        
</head>
<body>


<script type="text/javascript"><!--
    $(document).ready(function () {

        $('.well').popup({
            pagecontainer: '.container',
            transition: 'all 0.3s'
        });

    });
    //-->
</script>



<!--[if lt IE 9]>
<div class="old-browser"><?php echo $this->journal2->settings->get('old_browser_message', 'You are using an old browser. Please <a href="http://windows.microsoft.com/en-us/internet-explorer/download-ie">upgrade to a newer version</a> or <a href="http://browsehappy.com/">try a different browser</a>.'); ?></div>
<![endif]-->
<?php if ($this->journal2->settings->get('config_header_modules')):  ?>
<?php echo $this->journal2->settings->get('config_header_modules'); ?>
<?php endif; ?>
<?php
    $header_type = $this->journal2->settings->get('header_type', 'default');
    if ($header_type === 'center') {
        if (!$this->journal2->settings->get('config_secondary_menu')) {
            $header_type = 'center.nosecond';
        } else {
            if (!$currency && !$language) {
                $header_type = 'center.nolang-nocurr';
            } else if (!$currency) {
                $header_type = 'center.nocurr';
            } else if (!$language) {
                $header_type = 'center.nolang';
            }
        }
    }

    if ($header_type === 'mega') {
        if (!$this->journal2->settings->get('config_secondary_menu')) {
            $header_type = 'mega.nosecond';
        } else {
            if (!$currency && !$language) {
                $header_type = 'mega.nolang-nocurr';
            } else if (!$currency) {
                $header_type = 'mega.nocurr';
            } else if (!$language) {
                $header_type = 'mega.nolang';
            }
        }
    }

    if ($header_type === 'default' || $header_type === 'extended') {
        $no_cart = $this->journal2->settings->get('catalog_header_cart', 'block') === 'none';
        $no_search = $this->journal2->settings->get('catalog_header_search', 'block') === 'none';
        if ($no_cart && $no_search) {
            $header_type = $header_type . '.nocart-nosearch';
        } else if ($no_cart) {
            $header_type = $header_type . '.nocart';
        } else if ($no_search) {
            $header_type = $header_type . '.nosearch';
        }
    }
    if (class_exists('VQMod')) {
        global $vqmod;
        if ($vqmod !== null) {
            require $vqmod->modCheck(DIR_TEMPLATE . $this->config->get('config_template') . "/template/journal2/headers/{$header_type}.tpl");
        } else {
            require VQMod::modCheck(DIR_TEMPLATE . $this->config->get('config_template') . "/template/journal2/headers/{$header_type}.tpl");
        }
    } else {
        require DIR_TEMPLATE . $this->config->get('config_template') . "/template/journal2/headers/{$header_type}.tpl";
    }
?>
<?php if ($this->journal2->settings->get('config_top_modules')): ?>
<div id="top-modules">
   <?php echo $this->journal2->settings->get('config_top_modules'); ?>
</div>
<?php endif; ?>

<div class="extended-container">
<div id="container" class="j-container">

<?php if(isset($error)): /* v156 compatibility */ ?>
<?php if ($error) { ?>
    <div class="warning"><?php echo $error ?><img src="catalog/view/theme/default/image/close.png" alt="" class="close" /></div>
<?php } ?>
<?php endif; /* end v156 compatibility */ ?>
<div id="notification"></div>